var TenantID = "";
var pageIndex = 1;
var pageSize = 10;
var noticeMsg = new SinochemPromptMsg("", 3000);
var loadingMsg = new SinochemLoadingMsg();

var ChooseAddrId = "";
var currentItemIndex = "";
reloadData()
function reloadData() {
    loadingMsg.HideMsg();
    pageIndex = 1;
    GetData();
}

function getNextData() {
    beforeGetNextData();
    pageIndex++;
    GetData();
}

//获取地址列表
function GetData(isInit) {
    if (isInit) {
        loadingMsg.ShowLoadingMsg(msg_LoadPage);
    }

    var CallData = {
        LType : "L034",
        StrOptions : {
            QeuryType : "QT1501",
            TenantID : TenantID,
            PageIndex : pageIndex,
            PageSize : pageSize
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        if (result && result.Data) {
            var jsonArr = result.Data.Items;
            if (isInit == undefined) {
                if (pageIndex == 1) {
                    resetBV(0);
                } else {
                    resetBV(1);
                }
            }
            if (jsonArr.length <= 0) {
                loadingMsg.HideMsg();
                listNoData($("#AddressList"), isInit, pageIndex);
                return;
            }
            var checkedAddressId = getLocVal("checkedAddressId");
            
            for (var i = 0; i < jsonArr.length; i++) {
                if(checkedAddressId == jsonArr[i].AddrID){
                    jsonArr[i].selectFlag = "checked";
                }
                if (jsonArr[i].EPDefaultFlag == "Y") {
                    jsonArr[i].setDefaultDiv = "uhide";
                    getLocVal("checkedAddressId");
                } else {
                    jsonArr[i].isDefaultDiv = "uhide";
                }
            }
            var temp = getHtmlContent("AddressList");
            var htmllist = zy_tmpl(temp, jsonArr);
            if (pageIndex == 1) {
                $("#AddressList").html(htmllist);
            } else {
                $("#AddressList").append(htmllist);
            }
            BindClick($("[type=checkbox]"),function(objThis){
                var checkState = $(objThis).prop("checked");
                var indexSelect = $(objThis).parents(".addressItem").index();
                if(checkState == true){
                    setLocVal("checkedAddressId",jsonArr[indexSelect].AddrID);
                    // console.log(objThis);
                    $(objThis).parents(".addressItem").siblings().find("[type=checkbox]").prop("checked",false);
                    ueppScript("LogisticsDetailEdit","content","commenAddr("+jsonToStr(jsonArr[indexSelect])+","+currentItemIndex+")");
                    ueScript("","appcan.window.close(-1)");
                    this.push(checkedAddressId)
                }
            });
        }
        loadingMsg.HideMsg();
    }, 
    function(result) {
        if (isInit == undefined) {
            if (pageIndex == 1) {
                resetBV(0);
            } else {
                resetBV(1);
            }
        }
        var errorHtml = GetAjaxRequestFaillHtml("GetData(true)", "");
        $("#AddressList").html(errorHtml);
        loadingMsg.HideMsg();
    });
}


