function InitPage() {
    loadingMsg.ShowLoadingMsg("数据加载中...");
    bindUserData();
    ShowChangeBusiness();
    Menu.GetServiceData(TenantID);
    setPageBounce(2, ReloadData, null);
}

function ReloadData() {
    if (!countFlag) {
        return;
    }
    InitPage();
}

function bindUserData() {
    findPartnerName();
    $("#userName").text(UserInfo.UserName);
}

function findPartnerName () {
    var CallData = {
        DType : "D010",
        DID : getLocVal("CurrentTenantID"),
        StrOptions: {
            
        }
    };
    callAjaxService("POST", "QueryDetail", CallData, true, function(result) {
        if (result && result.Data && result.Data.length > 1) {
            $("#currentTenant").text(JSON.parse(result.Data).PartnerName);
        }
    })
}

//判断是否显示切换商户按钮
function ShowChangeBusiness() {
    var CallData = {
        LType : "L026",
        StrOptions : {}
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        if (result && result.Data && result.Data.length > 1) {
            $("#ChangeBusinessBtn").removeClass("uhide");
        }
    }, function(result) {
    });
}

//服务及菜单加载
var Menu = {
    //获取该用户有权限的服务
    GetServiceData : function(tenantID) {
        $("#MenuListDiv").html("");
        var CallData = {
            LType : "L085",
            StrOptions : {
                "RootTenantID" : UserInfo.TenantID || "AAA00001",
                "tenantID" : tenantID
            }
        };
        callAjaxService("POST", "QueryList", CallData, true, function(result) {
            if (result.Data && result.Data.length > 0) {
                var serviceData = result.Data;
                //收集所有符合显示条件的service 存放至resultServiceData
                var resultServiceData = [];
                $.each(MenuData.ServiceJson(), function(i, iobj) {
                    $.each(serviceData, function(j, jobj) {
                        var CurrMarketType = getLocVal("CurrMarketType") || "";
                        //与APP能展示的服务有交集
                        // if (iobj.SuItemCode == jobj.SuItemCode && iobj.MarketType == CurrMarketType) {
                        if (iobj.SuItemCode == jobj.SuItemCode) {
                            //筛选该服务下的APP定义的菜单数据
                            var menuJsonAPP = $.grep(MenuData.MenuJson(), function(item) {
                                return (item.Show != "uhide" && iobj.SuItemCode == item.SuItemCode);
                            });
                            //该服务在APP端有菜单，再去查找菜单
                            if (menuJsonAPP.length > 0) {
                                //1.调用接口，与数据库取交集，加载菜单
                                // Menu.GetMenuData(iobj, tenantID, menuJsonAPP);
                                resultServiceData.push(iobj)
                            }
                        }
                    });
                });
                if (resultServiceData.length > 0) {
                    var flag = {
                        SLength : resultServiceData.length,
                        SLengthCurr : 0
                    };
                    ServiceJsonList = [];
                    //循环服务，获取符合显示条件的菜单
                    $.each(resultServiceData, function(m, mobj) {
                        Menu.GetMenuData(flag, mobj, tenantID);
                    });
                } else {
                    countFlag = 1;
                    resetBV(0);
                    loadingMsg.HideMsg();
                }

            } else {
                listNoData($("#MenuListDiv"), "true", "1", "暂无商户服务");
                countFlag = 1;
                resetBV(0);
                loadingMsg.HideMsg();
            }
        }, function(result) {
            countFlag = 1;
            resetBV(0);
        });
    },
    GetMenuData : function(flag, serviceData, tenantID) {
        var CallData = {
            LType : "L086",
            StrOptions : {
                "tenantID" : tenantID,
                "suCodeItem" : serviceData.SuItemCode
            }
        };
        callAjaxService("POST", "QueryList", CallData, true, function(result) {
            flag.SLengthCurr++;
            //若数据库中该服务有菜单，则加载
            if (result.Data && result.Data.length > 0) {
                //取出所有APP定义的菜单,此时PrivCode无用
                var menuJsonAPPAll = $.grep(MenuData.MenuJson(), function(item) {
                    return (item.Show != "uhide" && serviceData.SuItemCode == item.SuItemCode);
                });

                //=======取相同Service下的菜单交集=======
                var menuJsonResult = result.Data;
                var menuJsonAPP = [];
                //根据菜单唯一标识筛选一遍
                $.each(menuJsonAPPAll, function(i, iobj) {
                    if (iobj.AppOnly == "1") {
                        menuJsonAPP.push(iobj);
                        return false;
                    }
                    $.each(menuJsonResult, function(j, jobj) {
                        if (iobj.PrivCode == jobj.PrivCode) {
                            menuJsonAPP.push(iobj);
                        }
                    });
                });
                //===================================
                if (menuJsonAPP.length > 0) {
                    //将符合条件的菜单放至MenuJsonList中
                    // var MenuJsonList = menuJsonAPPAll;
                    var MenuJsonList = menuJsonAPP;

                    //当前服务下的菜单排序
                    MenuJsonList.sort(function(a, b) {
                        return (parseInt(a.Order) - parseInt(b.Order));
                    });
                    serviceData.MenuData = MenuJsonList;
                    ServiceJsonList.push(serviceData);
                }
            }

            //最后一个服务
            if (flag.SLength == flag.SLengthCurr) {
                countFlag = 1;
                resetBV(0);
                Menu.InitMenu(ServiceJsonList);
                loadingMsg.HideMsg();
            }
        }, function(result) {
            countFlag = 1;
            resetBV(0);
        });
    },
    InitMenu : function(menuUlData) {
        //最后，Service排序
        menuUlData.sort(function(a, b) {
            return (parseInt(a.Order) - parseInt(b.Order));
        });
        var menuJson = [];
        var loopResult = true;
        $.each(menuUlData, function(i, iobj) {
            $.each(iobj.MenuData, function(j, jobj) {
                if (menuJson.length < 11) {
                    menuJson.push(jobj);
                } else {
                    menuJson.push(MenuData.MenuJsonAll()[0]);
                    loopResult = false;
                    return false;
                }
            });
            if (!loopResult) {
                return false;
            }
        });
        if (menuJson.length > 0) {
            var templi = getHtmlContent("MenuliTempl");
            var htmllistli = zy_tmpl(templi, menuJson);
            $("#MenuListDiv").html(htmllistli);

            $("#MenuListDiv .shanghuMenuList_li").bind("click", function() {
                var fun = $(this).attr("MenuFunction");
                eval(fun);
            });
        } else {
            var errorHtml = GetAjaxRequestFaillHtml("", "暂无服务");
            $("#MenuListDiv").html(errorHtml);
        }
        loadingMsg.HideMsg();
        if(getLocVal("forWorkPage") && getLocVal("forWorkPage") == "true"){
            IsNews(getLocVal("CurrentMarketID"));
        }
    }
}