(function(w) {
    w.CircleLoading = function() {
        this.X = 0;
        this.Y = 0;
        this.R = 0;
        this.circleCanvas = '';
        this.ID = "loading";
        this.PercentID = "percent";
        this.FrameID = "cFrame";
        this.MarkID = "cMark";
        this.MarkWidth = 0;
        if ($("#" + this.ID).length == 0) {
            this.circleCanvas = '<div id="' + this.FrameID + '" class="loadingFrame"><div id="' + this.MarkID + '" class="loadingFrameMark"></div></div><div class="ub ub-ac ub-pc loadingText uhide" id="' + this.PercentID + '"></div><canvas id="' + this.ID + '" class="loading">Your browser does not support the HTML5 canvas tag.</canvas>';
            $(window.document.body).append(this.circleCanvas);
        }
    }

    $.extend(CircleLoading.prototype, {
        SetCanvas : function(l, t, w, h) {
            var offset = w * 0.2;
            $("#" + this.PercentID + ",#" + this.ID).css("left", l + offset / 2.5);
            $("#" + this.PercentID + ",#" + this.ID).css("top", t + offset / 2.5);
            $("#" + this.PercentID).css("width", w - offset / 1.25);
            $("#" + this.PercentID).css("height", h - offset / 1.25);
            $("#" + this.ID)[0].width = w - offset / 1.25;
            $("#" + this.ID)[0].height = h - offset / 1.25;
            $("#" + this.FrameID).css("left", l - offset / 2);
            $("#" + this.FrameID).css("top", t - offset / 2);
            $("#" + this.FrameID).css("width", w + offset);
            $("#" + this.FrameID).css("height", h + offset);

            this.MarkWidth = w - offset / 2;
            $("#" + this.MarkID).css("height", h - offset / 2);
            var markLeft = -parseFloat($("#" + this.MarkID).css("border-left-width"));
            var markTop = -parseFloat($("#" + this.MarkID).css("border-top-width"));
            $("#" + this.MarkID).css("left", markLeft + offset / 1.36);
            $("#" + this.MarkID).css("top", markTop + offset / 1.36);

            this.X = $("#" + this.ID)[0].width / 2;
            this.Y = $("#" + this.ID)[0].height / 2;
            this.R = this.X - 1;
        },
        DrawCircle : function(percent) {
            $("#" + this.MarkID).css("width", this.MarkWidth);
            //清空
            this.ClearCanvas();
            if (percent == 100) {
                return;
            }
            var c = document.getElementById(this.ID);
            var ctx = c.getContext("2d");

            ctx.fillStyle = "#000000";
            ctx.strokeStyle = "#000000";
            ctx.globalAlpha = 0.5;
            ctx.beginPath();

            ctx.moveTo(this.X, this.Y);
            ctx.arc(this.X, this.Y, this.R, 1.5 * Math.PI + 6.28 * (percent / 100), 1.5 * Math.PI, false);
            ctx.fill();
            ctx.stroke();
            $("#" + this.PercentID).text(percent + "%");
        },
        FigureOutPosition : function(obj) {
            this.SetCanvas($(obj).offset().left, $(obj).offset().top, $(obj).offset().width, $(obj).offset().height);
        },
        ClearCanvas : function() {
            $("#" + this.ID)[0].height = $("#" + this.ID)[0].height;
        },
        RemoveLoadingControl : function() {
            $("#" + this.ID + ",#" + this.PercentID + ",#" + this.FrameID + ",#" + this.MarkID).remove();
        }
    });
})(window)
