/*客户端是否为IOS系统*/
if (!isIOS || isIOS == "") {
    var isIOS = window.navigator.userAgent.indexOf('iPhone') >= 0 || window.navigator.userAgent.indexOf('iPad') >= 0 || window.navigator.userAgent.indexOf('iPod') >= 0;
}
/**
 * 关闭遮罩
 */
function delloading() {
    if ($('.zhezhao').length > 0) {
        $('.zhezhao').remove();
    }
    $('.spinner').remove();
    $('#loading').remove();
}

function addmotai() {
    delloading();
    $("<div class='zhezhao' id='zhezhao'></div>").appendTo(document.body);
    var bheight = $(document).height();
    $(".zhezhao").css("height", bheight);
}

//计算弹框位置
function setApprovalDivPosition(approvalDiv) {
    if (approvalDiv && $(approvalDiv).length > 0) {
        var dHeight = $(document).height();
        var wHeight = $(window).height();
        var dWidth = $(document).width();
        var wWidth = $(window).width();
        var scrollTop = window.document.body.scrollTop || window.document.documentElement.scrollTop;
        var msgHeight = $(approvalDiv).height();
        //上移大约一个header高度
        $(approvalDiv).css("top", scrollTop + (wHeight - msgHeight) / 2 - wHeight * 0.08);

        //调整宽度
        if ($(approvalDiv).width() > wWidth * 0.8) {
            $(approvalDiv).width("85%");
        }
        $(approvalDiv).css("left", (wWidth - $(approvalDiv).width()) / 2 + (dWidth - wWidth));
    }
}


$(window).bind("orientationchang", function() {
    resetMsgControl();
});
$(window).bind("resize", function() {
    resetMsgControl();
});

//解决ios无法响应window.onresize事件的问题
if (isIOS) {
    $("input").bind("blur", function() {
        setTimeout(function() {
            resetMsgControl();
        }, 150);
    });
    $(window.document.body).bind("DOMNodeInserted", function() {
        $("input").unbind("blur");
        $("input").bind("blur", function() {
            setTimeout(function() {
                resetMsgControl();
            }, 150);
        });
    });
    $(window.document.body).bind("DOMNodeRemoved", function() {
        $("input").unbind("blur");
        $("input").bind("blur", function() {
            setTimeout(function() {
                resetMsgControl();
            }, 150);
        });
    });
}
function resetMsgControl() {
    var bheight = $(document).height();
    $(".zhezhao").css("height", bheight);

    //重新计算弹框位置
    setApprovalDivPosition($("#ShowApprovalDiv"));
}

var resetPositionID = 0;
var oldScrollTop = 0;
(function(w) {
    var Sinochem_ShowMsg = {
        //显示提示框
        Show : function(result, title, msg, t) {
            //禁止页面滚动
            $(window.document.documentElement).bind("touchmove", function() {
                return false;
            });
            if (this.timeoutNo == -1) {
                if (this.hasCover) {//如果有遮罩，则只关闭其他提示框即可,防止关闭遮罩再打开，页面闪动
                    this.HideMsgDiv();
                } else {
                    this.HideNow();
                }
            } else {
                clearTimeout(this.timeoutNo);
            }
            if ($(".ShowMsgDiv").length <= 0) {
                if (this.hasCover) {
                    addmotai();
                    ueScript("", "addmotai()");
                    appcan.window.publish("AddPageCover", "");
                }
                //提示框框架
                var ihtml = "";
                ihtml += '<div id="ShowApprovalDiv" class="ub ub-ver ShowMsgDiv msgShadow uhide animated">';
                ihtml += '  <div id="title" class="title uhide"></div>'
                ihtml += '    <div id="infoContainer" class="ub ub-f1 ub-ac" style="height:auto;">';
                ihtml += '            <div id="ShowApprovalImg" class="ub-img5"></div>';
                ihtml += '        <div id="ShowApprovalFont" style="padding-left: .1rem;" class="ub ub-f1">';
                ihtml += '            <div class="text ub-f1 wordBreak"></div>';
                ihtml += '        </div>';
                ihtml += '    </div>';
                ihtml += '</div>';
                $(document.body).append(ihtml);

                //图片样式及文字替换
                if (title && title != "") {
                    $("#ShowApprovalDiv #title").text(title);
                    $("#ShowApprovalDiv #title").removeClass("uhide");
                }

                if (result == "Y") {
                    //成功
                    $("#ShowApprovalImg").removeClass("imgDealFail");
                    $("#ShowApprovalImg").addClass("imgDealOK");
                    $("#ShowApprovalFont .text").text(msg);
                } else if (result == "N") {
                    //失败
                    $("#ShowApprovalImg").removeClass("imgDealOK");
                    $("#ShowApprovalImg").addClass("imgDealFail");
                    $("#ShowApprovalFont .text").text(msg);
                } else if (result == "W") {
                    //警告
                    $("#ShowApprovalImg").removeClass("imgDealOK");
                    $("#ShowApprovalImg").addClass("imgDealWarn");
                    $("#ShowApprovalFont .text").text(msg);
                } else if (result == "M") {
                    //消息
                    $("#ShowApprovalImg").removeClass("imgDealOK");
                    $("#ShowApprovalImg").addClass("imgDealMsg");
                    $("#ShowApprovalFont .text").text(msg);
                } else {
                    $("#ShowApprovalFont").css("padding-left", "0px");
                    $("#ShowApprovalFont .text").text(msg);
                    $("#ShowApprovalFont").removeClass("ub-f1");
                }

                switch(this.textAlign) {
                case "center":
                    $("#infoContainer").addClass("ub-pc");
                    break;
                case "right":
                    $("#infoContainer").addClass("ub-pe");
                    break;
                }

                if (this.hasRemindingLine) {
                    $("#ShowApprovalDiv").append('<div class="remindingLine"><input id="cbReminding" type="checkbox"><span>不再提醒</span></input></div>');
                    $("#cbReminding").next().click(function() {
                        $("#cbReminding").click();
                    });
                }

                if (this.hasConfirmBtn) {
                    var msgobj = this;
                    switch(this.confirmationType) {
                    case 1:
                        $("#ShowApprovalDiv").append('<div id="confirmBtn" class="confirm">' + this.hasConfirmationBtnText + '</div>');
                        //appcan.button的实现方式就是ontouchstart,而且方便调试，请勿变更
                        appcan.button("#confirmBtn", "btn-act", function(e) {
                            e.preventDefault();
                            if (msgobj.hasRemindingLine && $("#cbReminding").prop("checked")) {
                                setLocVal(msgobj.remindingKey, "N");
                            }
                            msgobj.confirmFunction();
                            msgobj.Hide();
                        });
                        break;
                    case 2:
                        $("#ShowApprovalDiv").css("padding", "0px;");
                        $("#infoContainer").css("margin", ".3rem .3rem 0rem .3rem;");
                        $(".remindingLine").css("margin", ".25rem .3rem 0rem .3rem;");
                        $("#ShowApprovalDiv").append('<div class="ub confirmationType2"><div id="cancelBtn" class="cancel ub-f1">'+msgobj.cancleBtnText+'</div><div id="confirmBtn" class="confirm ub-f1">'+msgobj.confirmBtnText+'</div></div>');
                        appcan.button("#confirmBtn", "btn-act", function(e) {
                            e.preventDefault();
                            msgobj.Hide(msgobj.confirmFunction);
                        });
                        appcan.button("#cancelBtn", "btn-act", function(e) {
                            e.preventDefault();
                            msgobj.Hide(msgobj.cancelFunction);
                        });
                        break;
                    }
                }

                if (this.hasLoadingImg) {
                    $("#ShowApprovalFont").css("padding-left", ".2rem");
                    $("#ShowApprovalFont").before("<div class='ub-img5 imgLoading'></div>");
                }

                $("#ShowApprovalDiv").removeClass("uhide");
                //先画出来 才有弹框高度
                $("#ShowApprovalDiv").css("top", 0);
                //计算弹框位置
                setApprovalDivPosition($("#ShowApprovalDiv"));
                //弹动效果(影响动态计算的位置，有更好的解决办法之前暂不使用)
                //$("#ShowApprovalDiv").addClass("bounceIn");

                if (t) {
                    $(".zhezhao").on('touchend', function(e) {
                        e.preventDefault();
                        setTimeout(function(){
                            Sinochem_ShowMsg.HideNow();
                            clearTimeout(Sinochem_ShowMsg.timeoutNo);
                           //关闭提示后，紧接着再弹出的提示框不受t的影响
                        },300);
                    });
                    this.timeoutNo = setTimeout(function() {
                        Sinochem_ShowMsg.Hide();
                    }, t);
                }

            }
        },
        //隐藏提示框
        Hide : function(cb) {
            //$("#ShowApprovalDiv").removeClass("bounceIn");
            //$("#ShowApprovalDiv").addClass("bounceOut");
            $("#ShowApprovalDiv").remove();
            if (this.hasCover) {
                setTimeout(function() {
                    delloading();
                    ueScript("", "delloading()");
                    appcan.window.publish("DeletePageCover", "");
                    $(window.document.documentElement).unbind("touchmove");
                    if (cb) {
                        cb();
                    }
                }, 360);
            }
        },
        //隐藏提示框(立即关闭遮罩)
        HideNow : function() {
            $("#ShowApprovalDiv").remove();
            //if (this.hasCover) {
            delloading();
            ueScript("", "delloading()");
            appcan.window.publish("DeletePageCover", "");
            $(window.document.documentElement).unbind("touchmove");
            //}
        },
        //只关闭提示框
        HideMsgDiv : function() {
            $("#ShowApprovalDiv").remove();
        }
    }

    w.SinochemMsg = function(params) {
        this.SetDefaultConfig();
        if (params) {
            for (var key in params ) {
                Sinochem_ShowMsg[key] = params[key];
            }
        }
        this.MsgConfig = {};
    }
    $.extend(SinochemMsg.prototype, {
        ShowMsg : function(result, title, msg, t) {
            this.GetMsgConfig();
            Sinochem_ShowMsg.Show(result, title, msg, t);
        },
        HideMsg : function() {
            Sinochem_ShowMsg.HideNow();
        },
        SetDefaultConfig : function() {
            var config = {
                timeoutNo : -1,
                hasCover : true, //是否加遮罩
                confirmationType : 1, //带按钮的弹框类型（1：单个确认按钮，2：带有确认及取消按钮）
                hasConfirmBtn : false, //是否显示确认（操作）按钮
                hasConfirmationBtnText : "确认", //单个确认按钮的文字
                confirmFunction : function() {
                    //确认按钮的事件
                },
                cancelFunction : function() {
                    //取消按钮的事件
                },
                hasRemindingLine : false, //是否带有不再提醒的复选框
                remindingKey : "", //设置不再提醒标识的key值
                textAlign : "left", //文本对其方式
                hasLoadingImg : false,
                confirmBtnText:"确定",
                cancleBtnText:"取消",
            }
            for (var ck in config) {
                Sinochem_ShowMsg[ck] = config[ck];
            }
        },
        GetMsgConfig : function() {
            this.SetDefaultConfig();
            if (this.MsgConfig != "") {
                for (var key in this.MsgConfig) {
                    Sinochem_ShowMsg[key] = this.MsgConfig[key];
                }
            }
        },
        SetMsgConfig : function() {
            for (var key in Sinochem_ShowMsg) {
                this.MsgConfig[key] = Sinochem_ShowMsg[key];
            }
        }
    });

    w.SinochemRemindingMsg = function(key) {
        SinochemMsg.call(this, {});
        Sinochem_ShowMsg.hasConfirmBtn = true;
        Sinochem_ShowMsg.hasRemindingLine = true;
        Sinochem_ShowMsg.remindingKey = key;
        this.SetMsgConfig();
    }
    SinochemRemindingMsg.prototype = new SinochemMsg();
    $.extend(SinochemRemindingMsg.prototype, {
        ShowRemindingMsg : function(title, msg) {
            if (getLocVal(Sinochem_ShowMsg.remindingKey) != "N") {
                this.ShowMsg("", title, msg);
            }
        }
    });

    w.SinochemConfirmationMsg = function(imgF, confirm, type, cancel,confirmBtnText,cancleBtnText) {
        SinochemMsg.call(this, {});
        this.imgFlag = "";
        Sinochem_ShowMsg.hasConfirmBtn = true;
        if (type) {
            Sinochem_ShowMsg.confirmationType = type;
        }
        if (confirm) {
            Sinochem_ShowMsg.confirmFunction = confirm;
        }
        if (cancel) {
            Sinochem_ShowMsg.cancelFunction = cancel;
        }
        if (confirmBtnText) {
            Sinochem_ShowMsg.confirmBtnText = confirmBtnText;
        }
        if (cancleBtnText) {
            Sinochem_ShowMsg.cancleBtnText = cancleBtnText;
        }
        if (imgF && imgF != "") {
            this.imgFlag = imgF;
        }
        this.SetMsgConfig();
    }
    SinochemConfirmationMsg.prototype = new SinochemMsg();
    $.extend(SinochemConfirmationMsg.prototype, {
        ShowConfirmationMsg : function(title, msg) {
            this.ShowMsg(this.imgFlag, title, msg);
        }
    });

    w.SinochemPromptMsg = function(imgF, t) {
        SinochemMsg.call(this, {});
        this.imgFlag = "";
        this.time == null;
        if (imgF && imgF != "") {
            this.imgFlag = imgF;
        }
        if (t) {
            this.time = t;
        }
        Sinochem_ShowMsg.textAlign = "center";
        this.SetMsgConfig();
    }
    SinochemPromptMsg.prototype = new SinochemMsg();
    $.extend(SinochemPromptMsg.prototype, {
        ShowPromptMsg : function(msg) {
            this.ShowMsg(this.imgFlag, "", msg, this.time);
        }
    });

    w.SinochemLoadingMsg = function(isCover) {
        SinochemMsg.call(this, {});
        Sinochem_ShowMsg.textAlign = "center";
        Sinochem_ShowMsg.hasLoadingImg = true;
        if (isCover && isCover == "Y") {
            Sinochem_ShowMsg.hasCover = true;
        } else {
            Sinochem_ShowMsg.hasCover = false;
        }
        this.SetMsgConfig();
    }
    SinochemLoadingMsg.prototype = new SinochemMsg();
    $.extend(SinochemLoadingMsg.prototype, {
        ShowLoadingMsg : function(msg) {
            this.ShowMsg("", "", msg);
        }
    });
})(window);

/**
 * 显示加载框
 * @param String mes 显示的提示语
 * @param String t  毫秒数 窗口存在时间 有的话显示框不显示那个“圈”，并且在t时间后消失
 */
var loadingMsg = new SinochemLoadingMsg();
var noticeMsg ="";
function showToast(mes, t, msgType) {
   loadingMsg.ShowLoadingMsg(mes);
}

/**
 * 手动关闭加载框
 */
function closeToast() {
    loadingMsg.HideMsg();
}

/**
 * 询问提示框
 * @param String str 提示语
 * @param String callback 回调函数
 */
function showConfirm(str, callback){
   var validMsg = new SinochemConfirmationMsg("", callback, 2);
   validMsg.ShowConfirmationMsg("", str);
}

/**
 * 消息提示框
 * @param String str 提示语
 */
function showMessage (str) {
   noticeMsg = new SinochemPromptMsg("M", 3000);
   noticeMsg.ShowPromptMsg(str);
}

/**
 * 提醒提示框
 * @param String str 提示语
 */
function showAlert(str) {
   var validMsg = new SinochemConfirmationMsg("", null);
   validMsg.ShowConfirmationMsg("", str);
}

/**
 * 成功 弹出框
 * @param String str 提示语
 */
function showSucceed(str) {
   noticeMsg = new SinochemPromptMsg("Y", 3000);
   noticeMsg.ShowPromptMsg(str);
}

/**
 * 错误 弹出框
 * @param String str 提示语
 */
function showError(str) {
   noticeMsg = new SinochemPromptMsg("N", 3000);
   noticeMsg.ShowPromptMsg(str);
}

/**
 * 警告 弹出框
 * @param String str 提示语
 */
function showWarn(str) {
   var noticeMsg = new SinochemPromptMsg("W", 3000);
   noticeMsg.ShowPromptMsg(str);
}
//公共变量
var successMsg = null;
var noticeMsg = null;
var warningMsg = null;
var promptMsg = null;
var loadingMsg = null;
if ( typeof (SinochemPromptMsg) != "undefined") {
    successMsg = new SinochemPromptMsg("Y", 3000);
    noticeMsg = new SinochemPromptMsg("N", 3000);
    warningMsg = new SinochemPromptMsg("W", 3000);
    promptMsg = new SinochemPromptMsg("M", 3000);
    loadingMsg = new SinochemLoadingMsg();
}