//var AppStorage = "box://widget/plugin";
var AppStorage = "wgts://";
var VersionInfo = null;
var loading = null;
var OldVersion = null;
var warningMsg = "";
var appUpdateLoadingMsg = "";
function checkWidgetVersion(mappid, loadEle, cb) {
    warningMsg = new SinochemPromptMsg("W", 3000);
    appUpdateLoadingMsg = new SinochemLoadingMsg();
    if (mappid && mappid != "") {
        var UserCode = getLocVal('UserCode');
        var file = uexFileMgr.open({
            path: "wgts://"+mappid+"/config.xml",
            mode: 3
        });     
        uexFileMgr.readFile(file, -1,0,function(error,data){
            if(!error){
                // var aindex=data.lastIndexOf("version")+9;
                // var versionID=data.substring(aindex,aindex+10);
                VersionInfo = getLocVal("VersionInfo") || "[]";
                VersionInfo = JSON.parse(VersionInfo);
                OldVersion = VersionInfo;
                if(VersionInfo.length > 0){
                    for(var i in VersionInfo){
                        if(VersionInfo[i].AppID == mappid){
                            var versionID = VersionInfo[i].Version;
                        }
                    }
                }else{
                    var versionID = "";
                }
                getAppupdate(UserCode, mappid, loadEle, cb,versionID);
            }
            else{
                getAppupdate(UserCode, mappid, loadEle, cb,"");
            }
        }); 
        
    } else {
        setLocVal("OpeningWidget", "N");
        warningMsg.ShowPromptMsg("AppID配置为空，请联系管理员");
    }
}

function getAppupdate(UserCode, mappid, loadEle, cb,versionID) {
    appUpdateLoadingMsg.ShowLoadingMsg("正在打开，请稍候...");
    var CallData = {
        "userCode" : getLocVal('UserCode'),
        "appID" : mappid,
        "Platform" : isIOS ? "iphone" : "android",
        "StrOptions":{
            
        }
        
    };
    callAjaxService("GET", "GetNewestVersion", CallData, true, function(data) {
        logs("VersionInfo:" + getLocVal("VersionInfo"));
        if (data.ResultCode == "0") {
            var versionList = data.Data;
            if (versionList.length <= 0) {
                cb();
                setLocVal("OpeningWidget", "N");
                warningMsg.ShowPromptMsg("应用不存在，请联系管理员");
                return;
            }
            var upNum = 0;
            var UpdateList = [];
            var Sobj = versionList[0];
            var updateInfo = {};
            if ((versionID==""||versionID!=Sobj.version)&&Sobj.pkgFileUrl!="") {
                updateInfo.pkgFileUrl = Sobj.pkgFileUrl;
                // setLocVal("VersionInfo", JSON.stringify(VersionInfo));
                if(VersionInfo.length > 0){
                    var exitVerFlag = false;
                    for(var i in VersionInfo){
                        if(VersionInfo[i].AppID == mappid){
                            exitVerFlag = true;
                            VersionInfo[i].Version = Sobj.version;
                        }
                    }
                    if(exitVerFlag == false){
                        VersionInfo.push({
                            AppID : widgetAppID,
                            Version : Sobj.version
                        })      
                    }
                }else{
                    VersionInfo.push({
                        AppID : widgetAppID,
                        Version : Sobj.version
                    })
                }
                appUpdateLoadingMsg.ShowLoadingMsg("正在下载插件，请稍候...");
                updateApp(updateInfo.pkgFileUrl, mappid, loadEle, cb);
            } else {
                appUpdateLoadingMsg.HideMsg();
                if (cb) {
                    cb();
                }
            }
        } else {
            appUpdateLoadingMsg.HideMsg();
            setLocVal("OpeningWidget", "N");
            warningMsg.ShowPromptMsg("调用更新接口时发生错误！");
        }
    }, function() {
        appUpdateLoadingMsg.HideMsg();
        setLocVal("OpeningWidget", "N");
        warningMsg.ShowPromptMsg("网络超时，请稍候重试！");
    });
}

function updateApp(downurl, moudlename, loadEle, cb) {
    var savePath = AppStorage + "UpDate_" + moudlename + ".zip";
    if (loadEle) {
        loading = new CircleLoading();
        loading.FigureOutPosition($(loadEle));
    }
    logs("  DownLoaPath:" + savePath);
    try {
        downFile(downurl, savePath, function(savePath) {
            logs("  UZipLocPath---" + savePath);
            //showToast("开始解压文件");
            uexZip.unzip(savePath, AppStorage, function(data) {
                if (data == 0) {
                    logs("  UZipSucceed---");
                    //showToast("解压完成");
                    DeleteUpZip(savePath, cb);
                } else {
                    logs("  UZipError---");
                    appUpdateLoadingMsg.HideMsg();
                    if (loading) {
                        loading.RemoveLoadingControl();
                    }
                    setLocVal("OpeningWidget", "N");
                    warningMsg.ShowPromptMsg("解压失败");
                    VersionInfo = OldVersion;
                }
            });
        });
    } catch(e) {
        appUpdateLoadingMsg.HideMsg();
        setLocVal("OpeningWidget", "N");
        logs(e.name + ": " + e.message);
        warningMsg.ShowPromptMsg(e.name + ": " + e.message);
    }
}

function downFile(downPath, savePath, cb) {
    logs("BdownPath:" + downPath);
    logs("BsavePath:" + savePath);
    try {
        var downloader = uexDownloaderMgr.create();
        uexDownloaderMgr.download(downloader, downPath, savePath, 1, function(fileSize, percent, status) {
            switch (status) {
            case 0:
                //showToast("下载进度:" + percent + "%");
                //return;
                if (loading) {
                    loading.DrawCircle(percent);
                }
                break;
            case 1:
                //showToast("下载完成");
                if (loading) {
                    loading.DrawCircle(100);
                }
                cb(savePath);
                uexDownloaderMgr.closeDownloader(downloader);
                break;
            case 2:
                //showToast("下载失败");
                uexDownloaderMgr.closeDownloader(downloader);
                appUpdateLoadingMsg.HideMsg();
                if (loading) {
                    loading.RemoveLoadingControl();
                }
                setLocVal("OpeningWidget", "N");
                warningMsg.ShowPromptMsg("下载失败");
                VersionInfo = OldVersion;
                setLocVal("VersionInfo", JSON.stringify(VersionInfo));
                break;
            }
        });
    } catch(e) {
        appUpdateLoadingMsg.HideMsg();
        if (loading) {
            loading.RemoveLoadingControl();
        }
        setLocVal("OpeningWidget", "N");
        logs(e.name + ": " + e.message);
        warningMsg.ShowPromptMsg(e.name + ": " + e.message);
        VersionInfo = OldVersion;
        setLocVal("VersionInfo", JSON.stringify(VersionInfo));
    }
}

function DeleteUpZip(savePath, cb) {
    logs("  DeleteZip---" + savePath);
    try {
        var ret = uexFileMgr.deleteFileByPath(savePath);
        if (ret) {
            logs("  DeleteZip---Succeed");
        } else {
            logs("  DeleteZip---Error");
        }
        //showToast("升级完成", 3000);
        OldVersion = VersionInfo;
        setLocVal("VersionInfo", JSON.stringify(VersionInfo));
        appUpdateLoadingMsg.HideMsg();
        if (loading) {
            loading.RemoveLoadingControl();
        }
        cb();
    } catch(e) {
        appUpdateLoadingMsg.HideMsg();
        if (loading) {
            loading.RemoveLoadingControl();
        }
        setLocVal("OpeningWidget", "N");
        logs(e.name + ": " + e.message);
        warningMsg.ShowPromptMsg(e.name + ": " + e.message);
        VersionInfo = OldVersion;
        setLocVal("VersionInfo", JSON.stringify(VersionInfo));
    }
}

