var VersionAppStorage = "res://";
var MainAppVersion = getLocVal("MainAppVersion");
var MainisShowMsg = true;
var MainisUpdateOn = true;
var versionID="";

function checkMainAPPVersion(cb) {
    var UserCode = getLocVal('usercode');
    if (isAndroid) {
        VersionAppStorage = "box://widget/";
    } else {
        var realPath = uexFileMgr.getFileRealPath(VersionAppStorage);
        VersionAppStorage = realPath.replace("wgtRes/", "").replace("wgtRes", "");
    }
    getAppVersionupdate(UserCode, cb);
}

function getAppVersionupdate(UserCode, cb) {
    if (MainisShowMsg) {
        $("#subtitle").html("正在检测主应用版本，请稍候...");
    }
    var file = uexFileMgr.open({
        path : VersionAppStorage + "/config.xml",
        mode : 3
    });
    uexFileMgr.readFile(file, -1, 0, function(error, data) {
        if (!error) {
            var widgetInfo;
            if(isIOS){
                widgetInfo = JSON.parse(uexWidgetOne.getCurrentWidgetInfo());
            }
            else{
                widgetInfo = uexWidgetOne.getCurrentWidgetInfo();
            }
            versionID = widgetInfo.version;
            $("#subtitle").html("检测到当前主应用版本："+versionID);
            var CallData = {
                "userCode" : getLocVal('UserCode'),
                "appID" : appUpdateID,
                "Platform" : isIOS ? "iphone" : "android",
                "StrOptions" : {

                }
            };
            callAjaxService("GET", "GetNewestVersion", CallData, true, function(data) {
                if (data.ResultCode == "0") {
                    var versionList = data.Data;
                    if (versionList.length <= 0) {
                        setLocVal("OpeningWidget", "N");
                        warningMsg.ShowPromptMsg("未找到主应用信息，请联系管理员");
                        return;
                    }
                    var Sobj = versionList[0];
                    if (versionID != "" &&(Sobj.version>versionID||MainAppVersion>versionID)&&Sobj.pkgFileUrl!="") {
                        if (MainisShowMsg) {
                            $("#subtitle").html("正在更新主应用，请稍候...");
                        }
                        updateMainApp(Sobj.pkgFileUrl, "Main", cb);
                    } else {
                        cb();
                    }
                } else {
                    appUpdateLoadingMsg.HideMsg();
                    setLocVal("OpeningWidget", "N");
                    warningMsg.ShowPromptMsg("调用更新接口时发生错误！");
                }
            }, function() {
                appUpdateLoadingMsg.HideMsg();
                setLocVal("OpeningWidget", "N");
                warningMsg.ShowPromptMsg("网络超时，请稍候重试！");
            });
        } else {
            cb();
        }
    });
}

function updateMainApp(downurl, moudlename, cb) {
    var savePath = VersionAppStorage + "UpDate_" + moudlename + ".zip";
    if (MainisShowMsg) {
        $("#subtitle").html("正在下载主应用，请稍候...");
    }
    try {
        downMainFile(downurl, savePath, function(savePath) {
            if (MainisShowMsg) {
                $("#subtitle").html("正在解压缩，请稍候...");
            }
            uexZip.unzip(savePath, VersionAppStorage, function(data) {
                if (data == 0) {
                    if (MainisShowMsg) {
                        $("#subtitle").html("正在删除临时文件，请稍候...");
                    }
                    DeleteMainUpZip(savePath, cb);
                } 
            });
        });
    } catch(e) {
        logs(e.name + ": " + e.message);
    }
}

function downMainFile(downPath, savePath, cb) {
    try {
        var downloader = uexDownloaderMgr.create();
        uexDownloaderMgr.download(downloader, downPath, savePath, 1, function(fileSize, percent, status) {
            switch (status) {
            case 0:
                if (MainisShowMsg) {
                    $(".jinduNum").html(percent + "%");
                    $(".jindu1").css("width", percent + "%");
                }
                break;
            case 1:
                if (MainisShowMsg) {
                    $(".jinduNum").html(percent + "%");
                    $(".jindu1").css("width", percent + "%");
                }
                cb(savePath);
                uexDownloaderMgr.closeDownloader(downloader);
                break;
            case 2:
                uexDownloaderMgr.closeDownloader(downloader);
                break;
            }
        });
    } catch(e) {
    }
}

function DeleteMainUpZip(savePath, cb) {
    try {
        var ret = uexFileMgr.deleteFileByPath(savePath);
        if (ret) {
            logs("  DeleteZip---Succeed");
        } else {
            logs("  DeleteZip---Error");
        }
        setLocVal("isLoadAdvert", "true");
        setLocVal("MainAppVersion",versionID);
        if (MainisShowMsg) {
            closeToast();
        }
        if (cb) {
            isReseart=true;
            cb();
        }
    } catch(e) {
        logs(e.name + ": " + e.message);
    }
}

