var pageIndex = 1;
var TenantID = "";
var OrderID = "";
var Ref_TenantID = "";
var order = {};

var noticeMsg = new SinochemPromptMsg("", 3000);
var loadingMsg = new SinochemLoadingMsg();

function InitPage() {
    loadingMsg.ShowLoadingMsg(msg_LoadPage);
    getOrderDetail(function(resultData) {
        order.CurrencyMark = resultData.Data.CurrencyMark || "";
        order.CurrencyName = resultData.Data.CurrencyName || "";
        order.Details = resultData.Data.Details;
        $("[fieldname=statusText]").text(resultData.Data.WLCLStateName);
        getData(true);
    });
}

function getData(isInit) {
    // if (isInit) {
    // loadingMsg.ShowLoadingMsg(msg_LoadPage);
    // }
    var CallData = {
        LType : "L122",
        StrOptions : {
            "TenantID" : TenantID,
            "OrderID" : OrderID
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        var jsonArr = result.Data;
        var newData = [];
        var money = 0;
        for (var i in jsonArr) {
            //配送BT01 自提BT02 配送计划BT03
            if (jsonArr[i].Header.BizType == "BT03") {
                PushData(jsonArr[i]);
                var newmdl = jsonArr[i].Header;
                if (newmdl.DeliveryTime != "" && newmdl.DeliveryTime != null) {
                    newmdl.DeliveryTime = formatedate2(newmdl.DeliveryTime);
                }
                if (newmdl.DeliveryTimeFrom != "" && newmdl.DeliveryTime != null) {
                    newmdl.DeliveryTimeFrom = formatedate2(newmdl.DeliveryTimeFrom);
                }
                newmdl.CurrencyMark = jsonArr[i].CurrencyMark;
                newmdl.RTransModeName = jsonArr[i].RTransModeName;
                newmdl.TransModeName = jsonArr[i].TransModeName;
                newmdl.ShipToPerIDTypeName = jsonArr[i].ShipToPerIDTypeName;

                money += jsonArr[i].Header.TransFee;
                newmdl.TransFee = FormateValue("Money", newmdl.TransFee);
                if (newmdl.TransFee == 0) {
                    newmdl.TransFee = "0.00";
                }
                newmdl.TransFeeText = order.CurrencyMark + newmdl.TransFee + order.CurrencyName;
                newmdl.TransPrice = FormateValue("Money", newmdl.TransPrice);
                if (newmdl.TransPrice == 0) {
                    newmdl.TransPrice = "0.00";
                }
                newmdl.TransPriceText = order.CurrencyMark + newmdl.TransPrice + order.CurrencyName;
                // newmdl.SubmitedBy = 
                newData.push(newmdl);
            }
        }
        if (newData.length <= 0) {
            listNoData($("#Logistics"), isInit, pageIndex);
            loadingMsg.HideMsg();
            return;
        }
        newData.sort(function(a, b) {
            return parseInt(a.BLSODRNo) - parseInt(b.BLSODRNo);
        });
        var num = 0;
        for (var i in newData) {
            num++;
            newData[i].Sort = num;
        }
        $("#SendNum").html(num);
        if (money == 0) {
            money = "0.00";
        }
        $("#MoneyTotal").html(order.CurrencyMark + FormateValue("Money", money) + order.CurrencyName);
        var temp = getHtmlContent("LogisticsTemp");
        var htmllist = zy_tmpl(temp, newData);
        $("#Logistics").html(htmllist);
        var WLCLState = getLocVal("WLCLState");
        if (WLCLState != "CS01" && WLCLState != "CS02") {
            $(".Maijia").removeClass("uhide");
        }
        bindSPList(order.Details);
        loadingMsg.HideMsg();
    }, function(result) {
        var errorHtml = GetAjaxRequestFaillHtml("getData(true)", "");
        $("#Logistics").html(errorHtml);
        loadingMsg.HideMsg();
    });
}     