function TGStart (cb) {
    var CallData = {
        RequestPath: "oil/v_1/GroupBuy/"+TGpageType,
        StrOptions: {
            PageIndex:pageIndex,
            PageSize:pageSize,
            MarketID:getLocVal("CurrentMarketID")
        }
    };
    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {
        loadingMsg.HideMsg();
        if (result.Success == true) {
            if (result && result.Data) {
                var jsonArr = result.Data.DataList;
                if(jsonArr && jsonArr.length > 0){
                    getServerTime(function(serverTime){
                        for(var z in jsonArr){
                            jsonArr[z].showStartTime = getTimeDifference2(serverTime, jsonArr[z].OnShelfTime, "T1", true);
                            jsonArr[z].showEndTime = getTimeDifference2(serverTime, jsonArr[z].OffShelfTime, "T1", true);
                        }
                        if(pageIndex == 1){
                            vueObj.dataList = jsonArr;
                        }else{
                            vueObj.dataList = vueObj.dataList.concat(jsonArr);
                        }
                        if(timer1){
                            clearInterval(timer1);
                        }
                        timer1 = setInterval(function(){
                            serverTime = getOneSeconds(5, serverTime);
                            for(var i in vueObj.dataList){
                                vueObj.dataList[i].showStartTime = getTimeDifference2(serverTime, vueObj.dataList[i].OnShelfTime, "T1", true);
                                vueObj.dataList[i].showEndTime = getTimeDifference2(serverTime, vueObj.dataList[i].OffShelfTime, "T1", true);
                            }
                        },5000);
                    });
                }else{
                    if(pageIndex == 1){
                        vueObj.dataList = [];
                        listNoData($("#noData"), isInit, pageIndex, "暂无数据");
                    }else{
                        promptMsg.ShowPromptMsg("没有更多数据了");
                    }
                }
            }
        } else {
            noticeMsg.ShowPromptMsg(result.Message);
        }
        if(cb){
            cb();
        }
    }, function(result) {
        if(cb){
            cb();
        }
    });
};

function MSStart (cb) {
    var CallData = {
        RequestPath: "oil/v_1/Seckill/"+MSpageType,
        StrOptions: {
            PageIndex:pageIndex,
            PageSize:pageSize,
            MarketID:getLocVal("CurrentMarketID")
        }
    };
    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {
        loadingMsg.HideMsg();
        if (result.Success == true) {
            if (result && result.Data) {
                var jsonArr = result.Data.DataList;
                if(jsonArr && jsonArr.length > 0){
                    getServerTime(function(serverTime){
                        for(var z in jsonArr){
                            jsonArr[z].showStartTime = getTimeDifference2(serverTime, jsonArr[z].OnShelfTime, "T1", true);
                            jsonArr[z].showEndTime = getTimeDifference2(serverTime, jsonArr[z].OffShelfTime, "T1", true);
                        }
                        if(pageIndex == 1){
                            vueObj.dataList = jsonArr;
                        }else{
                            vueObj.dataList = vueObj.dataList.concat(jsonArr);
                        }
                        if(timer1){
                            clearInterval(timer1);
                        }
                        timer1 = setInterval(function(){
                            serverTime = getOneSeconds(5, serverTime);
                            for(var i in vueObj.dataList){
                                vueObj.dataList[i].showStartTime = getTimeDifference2(serverTime, vueObj.dataList[i].OnShelfTime, "T1", true);
                                vueObj.dataList[i].showEndTime = getTimeDifference2(serverTime, vueObj.dataList[i].OffShelfTime, "T1", true);
                            }
                        },5000);
                    });
                }else{
                    if(pageIndex == 1){
                        vueObj.dataList = [];
                        listNoData($("#noData"), isInit, pageIndex, "暂无数据");
                    }else{
                        promptMsg.ShowPromptMsg("没有更多数据了");
                    }
                }
            }
        } else {
            noticeMsg.ShowPromptMsg(result.Message);
        }
        if(cb){
            cb();
        }
    }, function(result) {
        if(cb){
            cb();
        }
    });
};

function TGDetail (cb) {
    var CallData = {
        RequestPath: "oil/v_1/GroupBuy/"+TGDetailType,
        StrOptions: {
            ResID:getLocVal('Active_ResID'),
            SellerTenantID:getLocVal('Active_SellerTenantID'),
            MarketID : getLocVal("CurrentMarketID"),
        }
    };
    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {
        loadingMsg.HideMsg();
        if (result.Success == true) {
            if (result && result.Data) {
                vueObj.bottomType = result.Data.State;
                ueScript('', 'getBottomType("'+result.Data.State+'")');
                getServerTime(function(serverTime){
                    vueObj.TGorMSDetailJson = result.Data;
                    vueObj.showStartTime = getTimeDifference2(serverTime, vueObj.TGorMSDetailJson.OnShelfTime, "T1", true);
                    vueObj.showEndTime = getTimeDifference2(serverTime, vueObj.TGorMSDetailJson.OffShelfTime, "T1", true);
                    if(timer2){
                        clearInterval(timer2);
                    }
                    var timer2 = null;
                    timer2 = setInterval(function(){
                        serverTime = getOneSeconds(5, serverTime);
                        vueObj.showStartTime = getTimeDifference2(serverTime, vueObj.TGorMSDetailJson.OnShelfTime, "T1", true);
                        vueObj.showEndTime = getTimeDifference2(serverTime, vueObj.TGorMSDetailJson.OffShelfTime, "T1", true);
                    },5000);
                });
            }
        } else {
            submitFlage = false;
            noticeMsg.ShowPromptMsg(result.Message);
        }
        if(cb){
            cb();
        }
    }, function(result) {
        if(cb){
            cb();
        }
    });
};

function MSDetail (cb) {
    var CallData = {
        RequestPath: "oil/v_1/Seckill/SeckillMarketDetail",
        StrOptions: {
            ResID:getLocVal('Active_ResID'),
            SellerTenantID:getLocVal('Active_SellerTenantID'),
            MarketID : getLocVal("CurrentMarketID"),
        }
    };
    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {
        loadingMsg.HideMsg();
        if (result.Success == true) {
            if (result && result.Data) {
                vueObj.bottomType = result.Data.State;
                ueScript('', 'getBottomType("'+result.Data.State+'")');
                getServerTime(function(serverTime){
                    vueObj.TGorMSDetailJson = result.Data; 
                    vueObj.TGorMSDetailJson.GroupBuyPrice = result.Data.SeckillPrice;
                    vueObj.showStartTime = getTimeDifference2(serverTime, vueObj.TGorMSDetailJson.OnShelfTime, "T1", true);
                    vueObj.showEndTime = getTimeDifference2(serverTime, vueObj.TGorMSDetailJson.OffShelfTime, "T1", true);
                    if(timer2){
                        clearInterval(timer2);
                    }
                    var timer2 = null;
                    timer2 = setInterval(function(){
                        serverTime = getOneSeconds(5, serverTime);
                        vueObj.showStartTime = getTimeDifference2(serverTime, vueObj.TGorMSDetailJson.OnShelfTime, "T1", true);
                        vueObj.showEndTime = getTimeDifference2(serverTime, vueObj.TGorMSDetailJson.OffShelfTime, "T1", true);
                    },5000);
                });
            }
        } else {
            submitFlage = false;
            noticeMsg.ShowPromptMsg(result.Message);
        }
        if(cb){
            cb();
        }
    }, function(result) {
        if(cb){
            cb();
        }
    });
}

function Resource(){
    var CallData = {
        RequestPath: "oil/v_1/Seckill/ResourceBrowse",
        StrOptions: {
            sResID:getLocVal('Active_ResID'),
            marketID:getLocVal("CurrentMarketID"),
        }
    };
    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {})
 }
