function JingjiaStart (cb) {
    var CallData = {
        RequestPath: "oil/v_1/Auction/AuctionMarketActiveList",
        StrOptions: {
            PageIndex:pageIndex,
            PageSize:pageSize,
            MarketID : getLocVal("CurrentMarketID"),
        }
    };
    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {
        loadingMsg.HideMsg();
        if (result.Success == true) {
            if (result && result.Data) {
                var jsonArr = result.Data.DataList;
                if(jsonArr && jsonArr.length > 0){
                    getServerTime(function(serverTime){
                        for(var z in jsonArr){
                            jsonArr[z].showEndTime = getTimeDifference2(serverTime, jsonArr[z].EndTime, "T1", true);
                        }
                        if(pageIndex == 1){
                            vueObj.dataList = jsonArr;
                        }else{
                            vueObj.dataList = vueObj.dataList.concat(jsonArr);
                        }
                        if(timer1){
                            clearInterval(timer1);
                        }
                        timer1 = setInterval(function(){
                            serverTime = getOneSeconds(5, serverTime);
                            for(var i in vueObj.dataList){
                                vueObj.dataList[i].showEndTime = getTimeDifference2(serverTime, vueObj.dataList[i].EndTime, "T1", true);
                            }
                        },5000);
                    });
                }else{
                    if(pageIndex == 1){
                        vueObj.dataList = [];
                        listNoData($("#noData"), isInit, pageIndex, "暂无数据");
                    }else{
                        promptMsg.ShowPromptMsg("没有更多数据了");
                    }
                }
            }
        } else {
            noticeMsg.ShowPromptMsg(result.Message);
        }
        if(cb){
            cb();
        }
    }, function(result) {
        if(cb){
            cb();
        }
    });
}

function JingjiaComing (cb) {
    var CallData = {
        RequestPath: "oil/v_1/Auction/AuctionMarketUnActiveList",
        StrOptions: {
            PageIndex:pageIndex,
            PageSize:pageSize,
            MarketID : getLocVal("CurrentMarketID"),
        }
    };
    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {
        loadingMsg.HideMsg();
        if (result.Success == true) {
            if (result && result.Data) {
                var jsonArr = result.Data.DataList;
                if(jsonArr && jsonArr.length > 0){
                    getServerTime(function(serverTime){
                        for(var z in jsonArr){
                            jsonArr[z].showStartTime = getTimeDifference2(serverTime, jsonArr[z].StartTime, "T1", true);
                        }
                        if(pageIndex == 1){
                            vueObj.dataList = jsonArr;
                        }else{
                            vueObj.dataList = vueObj.dataList.concat(jsonArr);
                        }
                        if(timer1){
                            clearInterval(timer1);
                        }
                        timer1 = setInterval(function(){
                            serverTime = getOneSeconds(5, serverTime);
                            for(var i in vueObj.dataList){
                                console.log(vueObj.dataList[i].StartTime);
                                vueObj.dataList[i].showStartTime = getTimeDifference2(serverTime, vueObj.dataList[i].StartTime, "T1", true);
                            }
                        },5000);
                    });
                }else{
                    if(pageIndex == 1){
                        vueObj.dataList = [];
                        listNoData($("#noData"), isInit, pageIndex, "暂无数据");
                    }else{
                        promptMsg.ShowPromptMsg("没有更多数据了");
                    }
                }
            }
        } else {
            noticeMsg.ShowPromptMsg(result.Message);
        }
        if(cb){
            cb();
        }
    }, function(result) {
        if(cb){
            cb();
        }
    });
}

function JingjiaOver (cb) {
    var CallData = {
        RequestPath: "oil/v_1/Auction/AuctionMarketEndList",
        StrOptions: {
            PageIndex:pageIndex,
            PageSize:pageSize,
            MarketID : getLocVal("CurrentMarketID"),
        }
    };
    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {
        loadingMsg.HideMsg();
        if (result.Success == true) {
            if (result && result.Data) {
                var jsonArr = result.Data.DataList;
                if(jsonArr && jsonArr.length > 0){
                    if(pageIndex == 1){
                        vueObj.dataList = jsonArr;
                    }else{
                        vueObj.dataList = vueObj.dataList.concat(jsonArr);
                    }
                }else{
                    if(pageIndex == 1){
                        vueObj.dataList = [];
                        listNoData($("#noData"), isInit, pageIndex, "暂无数据");
                    }else{
                        promptMsg.ShowPromptMsg("没有更多数据了");
                    }
                }
            }
        } else {
            noticeMsg.ShowPromptMsg(result.Message);
        }
        if(cb){
            cb();
        }
    }, function(result) {
        if(cb){
            cb();
        }
    });
}