function init() {
    //初始化消息里列表对象
    msgListObj = new MessageList({
        StrOptions : {
            PageSize : 1,
            PageIndex : 1,
            TenantID : UserInfo.TenantID
        },
        CallBack : function(result) {
            var resultData = result.Data.Items;
            var item = result.ProcessObj.Obj;
            var index = result.ProcessObj.Index;
            if (resultData && resultData.length > 0) {
                var dataItem = resultData[0];
                dataItem.CreatedAt = dataItem.CreatedAt.replace("T", " ").replace(/\..*/g, "");
                if (msgIsNewStorage[dataItem.MsgCategory]) {
                    if (msgIsNewStorage[dataItem.MsgCategory].CreateDate < dataItem.CreatedAt) {
                        $(item).find(".dot").removeClass("uhide");
                        msgIsNewStorage[dataItem.MsgCategory].IsClicked = false;
                        msgIsNewStorage[dataItem.MsgCategory].CreateDate = dataItem.CreatedAt;
                    }
                    //如果时间相等，并且用户没有点击过，依然显示红点
                    if (msgIsNewStorage[dataItem.MsgCategory].CreateDate == dataItem.CreatedAt) {
                        if (!msgIsNewStorage[dataItem.MsgCategory].IsClicked) {
                            $(item).find(".dot").removeClass("uhide");
                        }
                    }
                } else {
                    $(item).find(".dot").removeClass("uhide");
                    msgIsNewStorage[dataItem.MsgCategory] = {
                        CreateDate : dataItem.CreatedAt,
                        IsClicked : false
                    }
                }
            }
            loadListNumber++
            if ($(".messageType").length == loadListNumber) {
                msgListObj.SetMessageIsNewStorage(UserInfo.UserCode, msgIsNewStorage);
                loadingMsg.HideMsg();
            }
        }
    });
}

appcan.button(".ContentDiv .more", "btn-act", function() {
    openWin("MyMessage", "../MyMessage.html")
});
appcan.button(".ShoppingCart", "btn-act", function() {
    openWin("ShoppingCart", "../ShoppingCart.html")
});

appcan.button(".messageType", "btn-act", function() {
    var typeName = $(this).find(".messageTypeName").text();
    var direction = $(this).attr("msgDirection");
    var category = $(this).attr("msgCategory");
    setLocVal("MessageType", trim(typeName));
    setLocVal("MsgDirection", direction);
    setLocVal("MsgCategory", category);
    openWin("MessageDetail", "../MessageDetail.html");
    $(this).find(".dot").addClass("uhide");

    msgIsNewStorage = msgListObj.GetMessageIsNewStorage(UserInfo.UserCode);
    msgIsNewStorage[category].IsClicked = true;
    msgListObj.SetMessageIsNewStorage(UserInfo.UserCode, msgIsNewStorage);
});

function bindNewMessageData() {
    loadListNumber = 0;
    msgIsNewStorage = msgListObj.GetMessageIsNewStorage(UserInfo.UserCode);

    loadingMsg.ShowLoadingMsg("数据加载中...");
    $(".messageType").each(function(index, i) {
        var direction = $(i).attr("msgDirection");
        var category = $(i).attr("msgCategory");
        msgListObj.GetMessageList({
            DirectType : direction,
            MsgCategory : category,
            MsgType : category,
            RootTenantID : UserInfo.TenantID
        }, {
            Obj : i,
            Index : index
        });
    });
}

function setDotToHide(mc) {
    if (mc != "") {
        $("[msgCategory=" + mc + "]").find(".dot").addClass("uhide");
    }
}

function setDotToShow(mc) {
    if (mc != "") {
        $("[msgCategory=" + mc + "]").find(".dot").removeClass("uhide");
    }
}

function ClearStorage() {
    new SinochemConfirmationMsg("", function() {
        clearup();
    }, 2).ShowConfirmationMsg("", "确定要清空缓存吗？");
}

function clearup() {
    new SinochemLoadingMsg("Y").ShowLoadingMsg("缓存清空中...");
    setLocVal("VersionInfo", "[]");
    setLocVal("thismasip", "");
    setLocVal("OpeningWidget", "");
    setTimeout(function() {
        noticeMsg = new SinochemPromptMsg("Y", 3000);
        noticeMsg.ShowPromptMsg("清空完成!");
    }, 3000);
}

function Signout() {
    new SinochemConfirmationMsg("", function() {
        setLocVal("UserCode", "");
        setLocVal("UserInfo", "");
        setLocVal("FromType","");
        setLocVal("LoginNumber","");
        setLocVal("lockPass","");
        setLocVal("GestureChengeFlag","");
        setLocVal("ChangeBusinessmen", "");  
        var Storage = window.localStorage;
        Storage.clear();
        setLocVal("loginoutFlag", "true");
        loginout(1);
    }, 2).ShowConfirmationMsg("", "确定要退出当前账号吗？");
}

function loginout(num) {
    if(getLocVal("UserCode") == ""){
        var systemVersion = "phone";
        if(isPhone){
            systemVersion = getSysVer();
        }
        if(systemVersion == "vivo" || systemVersion == "phone"){
            setLocVal("UserCode", "");
            setLocVal("UserInfo", "");
            setLocVal("FromType","");
            setLocVal("LoginNumber","");
            setLocVal("lockPass","");
            setLocVal("GestureChengeFlag","");
            setLocVal("ChangeBusinessmen", "");  
            var Storage = window.localStorage;
            Storage.clear();
            setTimeout(function(){
                ueScript('NavBottom0', 'closeUe(-1);');
                ueScript('NavBottom1', 'appcan.window.close(-1);');
                ueScript('NavBottom2', 'appcan.window.close(-1);');
                ueScript('NavBottom3', 'appcan.window.close(-1);');
                ueScript('Settings', 'appcan.window.close(-1);');
                ueScript('HomeNew', 'appcan.window.close(-1);');
                ueScript('Home', 'appcan.window.close(-1);');
                ueScript('GesturePassword', 'appcan.window.close(-1);');
            },200)
        }else{
            setTimeout(function(){
                uexWidgetOne.restart();
            },1000)
        }
    }else{
        num++;
        setLocVal("UserCode", "");
        loginout(num);
    }
}

appcan.switchBtn($(".switch"), function(obj, value) {
    var userCode = getLocVal("UserCode");
    if (value) {
        if (getLocVal("FXflag") && getLocVal("FXflag") == "FX") {
            $('.switch').css('background-color','#0583ff !important' );
        }else{
            $('.switch').css('background-color','#1c4561 !important');
        }
        setLocVal(userCode+"acceptPush", "true");
        uexWidget.setPushInfo(getLocVal("userid"), getLocVal("userid"));
    } else {
        setLocVal(userCode+"acceptPush", "false");
        $('.switch').css('background-color','#DDDDDD !important');
        uexWidget.setPushInfo("", "");
    }
}); 
