var BillList = getHtmlContent("BillList");
var BillTerms = getHtmlContent("BillTerms");
var NoTerms = getHtmlContent("NoTerms");
var oldList = [];
function getBuyerBalance (argument) {
    var CallData = {
        LType : "L195",
        StrOptions : {
            pageIndex : pageIndex,
            pageSize : pageSize,
            tenantID : getLocVal("CurrentTenantID")
        }                
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        if(result && result.Data){
            var item = result.Data.BalanceSummaryView;
            $(".eyeFlag").attr("moneyText",formatMoney4(item.AccBalanceAvlAmount));
        }
    });
}
function getMyBill(nowTime) {
    var CallData = {
        LType : "L160",
        StrOptions : {
            "TenantID" : TenantID,
            "iCalMonth" : "6",
            "dtEndTime" : nowTime,
            "pageIndex" : pageIndex,
            "pageSize" : pageSize
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        if (result && result.Data) {
            resetBV(0);
            var jsonArr = result.Data.Items;
            if (!jsonArr || jsonArr.length <= 0) {
                loadingMsg.HideMsg();
                $("#billBox").html("<div class='bc-text-Gray'>暂无账单</div>");
                return;
            }
            oldList = [];
            for(var i in jsonArr){
                jsonArr[i].InAmount = formatMoney4(jsonArr[i].InAmount);
                jsonArr[i].OutAmount = formatMoney4(Math.abs(jsonArr[i].OutAmount));
                jsonArr[i].Month = jsonArr[i].Month.toString();
                jsonArr[i].MonthDate = jsonArr[i].Month;
                jsonArr[i].Month = jsonArr[i].Month.substring(0,4)+"年"+jsonArr[i].Month.substring(4,6)+"月";
                var accbalentrylist = jsonArr[i].accbalentrylist;
                for(var z in accbalentrylist.Items){
                    var accbalentryEnd = accbalentrylist.Items[z].EntryTime;
                    var EntryID = accbalentrylist.Items[z].EntryID;
                    oldList.push(EntryID);
                    jsonArr[i].accbalentryEnd = accbalentryEnd;
                    jsonArr[i].EntryIDEnd = EntryID;
                    if(accbalentrylist.Items[z].BizAmount >= 0){
                        accbalentrylist.Items[z].moneyColor = "bc-text-Red";
                        accbalentrylist.Items[z].BizAmount = formatMoney4(accbalentrylist.Items[z].BizAmount);
                        accbalentrylist.Items[z].BizAmount = "+" + accbalentrylist.Items[z].BizAmount;
                    }else{
                        accbalentrylist.Items[z].BizAmount = formatMoney4(accbalentrylist.Items[z].BizAmount);
                    }
                    switch(accbalentrylist.Items[z].EntryType){
                        case "CABT00":
                            accbalentrylist.Items[z].msgIconImg = "css/images/Receivables.png";
                            break;
                        case "CABT01":
                            accbalentrylist.Items[z].msgIconImg = "css/images/Receivables.png";
                            break;
                        case "CABT02":
                            accbalentrylist.Items[z].RefObjID = accbalentrylist.Items[z].Ext_OrderID;
                            accbalentrylist.Items[z].msgIconImg = "css/images/payment.png";
                            break;
                        case "CABT03":
                            accbalentrylist.Items[z].RefObjID = accbalentrylist.Items[z].Ext_OrderID;
                            accbalentrylist.Items[z].msgIconImg = "css/images/payment.png";
                            break;
                        case "CABT04":
                            accbalentrylist.Items[z].RefObjID = accbalentrylist.Items[z].Ext_OrderID;
                            accbalentrylist.Items[z].msgIconImg = "css/images/TransferAccounts.png";
                            break;
                        case "CABT05":
                            accbalentrylist.Items[z].msgIconImg = "css/images/refund.png";
                            break;
                        case "CABT06":
                            accbalentrylist.Items[z].RefObjID = accbalentrylist.Items[z].Ext_OrderID;
                            accbalentrylist.Items[z].msgIconImg = "css/images/payment.png";
                            break;
                        case "CABT07":
                            accbalentrylist.Items[z].RefObjID = accbalentrylist.Items[z].Ext_OrderID;
                            accbalentrylist.Items[z].msgIconImg = "css/images/payment.png";
                            break;
                        case "CABT08":
                            accbalentrylist.Items[z].msgIconImg = "css/images/refund.png";
                            break;
                        default:
                            accbalentrylist.Items[z].msgIconImg = "css/images/Receivables.png";
                            break;
                    }
                    accbalentrylist.Items[z].EntryTimeText = formatedate3(accbalentrylist.Items[z].EntryTime,"D1");
                }
                if(accbalentrylist.ResultCount > pageSize){
                    jsonArr[i].showBillFlag = "";
                    jsonArr[i].showFlag = "true"
                }else{
                    jsonArr[i].showBillFlag = "uhide";
                    jsonArr[i].showFlag = "false"
                }
                if(accbalentrylist.ResultCount > 0){
                    jsonArr[i].BillTerms = zy_tmpl(BillTerms, accbalentrylist.Items);
                }else{
                    jsonArr[i].BillTerms = NoTerms;
                }
            }
            var htmllist = zy_tmpl(BillList, jsonArr);
            htmllist = $(htmllist);
            $(htmllist).each(function(index, i) {
                appcan.button($(i).find(".mouthBill"), "btn-act", function() {
                    var BillTime = jsonArr[index].MonthDate.substring(0,4) + "-" + jsonArr[index].MonthDate.substring(4,6);
                    var endBillTime = new Date(BillTime);
                    setLocVal("endBillTime",endBillTime);
                    openWin("MonthBill","MonthBill.html");
                });
                appcan.button($(i).find(".mouthFooter"), "btn-act", function() {
                    var json = jsonArr[index].accbalentrylist;
                    var BillTime = jsonArr[index].MonthDate.substring(0,4) + "-" + jsonArr[index].MonthDate.substring(4,6) + "-01";
                    var dtBeginTime = BillTime;
                    var dtEndTime = $(this).attr("accbalentryEnd");
                    getMonthBill($(i),dtBeginTime,dtEndTime);
                });
                appcan.button($(i).find(".changeBtn"), "btn-act", function (argument) {
                    var changeFlag = $(this).attr("changeFlag");
                    if(changeFlag == "true"){
                        $(this).attr("src","css/images/arrow1.png");
                        $(this).attr("changeFlag","false");
                        $(this).parents(".mouthItem").find(".mouthBody").addClass("uhide");
                        $(this).parents(".mouthItem").find(".mouthFooter").addClass("uhide");
                    }else{
                        $(this).attr("src","css/images/arrow2.png");
                        $(this).attr("changeFlag","true");
                        $(this).parents(".mouthItem").find(".mouthBody").removeClass("uhide");
                        if($(this).parents(".mouthItem").find(".mouthFooter").attr("showFlag") == "true"){
                            $(this).parents(".mouthItem").find(".mouthFooter").removeClass("uhide");
                        }
                    }
                })  
            });
            $("#billBox").html(htmllist);
            loadingMsg.HideMsg();
        } else {
            noticeMsg.ShowPromptMsg(result.ResultMsg);
        }
    }, function(result) {
        resetBV(0);
        var errorHtml = GetAjaxRequestFaillHtml("getbillBox(true)", "");
        $("#billBox").html(errorHtml);
        loadingMsg.HideMsg();
    });
}


function getMonthBill (obj,dtBeginTime,dtEndTime) {
    var CallData = {
        LType : "L161",
        StrOptions : {
            "TenantID" : TenantID,
            "dtBeginTime" : dtBeginTime,
            "dtEndTime" : dtEndTime,
            "pageIndex" : "1",
            "pageSize" : "2"
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        if (result && result.Data) {
            if(!result.Data.accbalentrylist){
                noticeMsg.ShowPromptMsg("没有更多数据了");
                $(obj).find(".mouthFooter").addClass("uhide");
                return;
            }
            var jsonArr = result.Data.accbalentrylist.Items;
            var ResultCount = result.Data.accbalentrylist.ResultCount;
            if (!jsonArr || jsonArr.length <= 0) {
                loadingMsg.HideMsg();
                $(obj).find(".mouthFooter").attr("showFlag","false");
                $(obj).find(".mouthFooter").addClass("uhide");
                return;
            }
            var jsonNew = [];
            var OldEntryID = $(obj).find(".mouthFooter").attr("EntryIDEnd");
            var newList = [];
            for(var i in jsonArr){
                for(var z in oldList){
                    if(jsonArr[i].EntryID == oldList[z]){
                        jsonArr[i].exFlag = 'false';
                    }
                }
                if(jsonArr[i].exFlag != "false"){
                    var accbalentryEnd = jsonArr[i].EntryTime;
                    var EntryID = jsonArr[i].EntryID;
                    $(obj).find(".mouthFooter").attr("accbalentryEnd",accbalentryEnd);
                    $(obj).find(".mouthFooter").attr("EntryIDEnd",EntryID);
                    if(jsonArr[i].BizAmount >= 0){
                        jsonArr[i].moneyColor = "bc-text-Red";
                        jsonArr[i].BizAmount = formatMoney4(jsonArr[i].BizAmount);
                        jsonArr[i].BizAmount = "+" + jsonArr[i].BizAmount;
                    }else{
                        jsonArr[i].BizAmount = formatMoney4(jsonArr[i].BizAmount);
                    }
                    switch(jsonArr[i].EntryType){
                        case "CABT00":
                            jsonArr[i].msgIconImg = "css/images/Receivables.png";
                            break;
                        case "CABT01":
                            jsonArr[i].msgIconImg = "css/images/Receivables.png";
                            break;
                        case "CABT02":
                            jsonArr[i].RefObjID = jsonArr[i].Ext_OrderID;
                            jsonArr[i].msgIconImg = "css/images/payment.png";
                            break;
                        case "CABT03":
                            jsonArr[i].RefObjID = jsonArr[i].Ext_OrderID;
                            jsonArr[i].msgIconImg = "css/images/payment.png";
                            break;
                        case "CABT04":
                            jsonArr[i].RefObjID = jsonArr[i].Ext_OrderID;
                            jsonArr[i].msgIconImg = "css/images/TransferAccounts.png";
                            break;
                        case "CABT05":
                            jsonArr[i].msgIconImg = "css/images/refund.png";
                            break;
                        case "CABT06":
                            jsonArr[i].RefObjID = jsonArr[i].Ext_OrderID;
                            jsonArr[i].msgIconImg = "css/images/payment.png";
                            break;
                        case "CABT07":
                            jsonArr[i].RefObjID = jsonArr[i].Ext_OrderID;
                            jsonArr[i].msgIconImg = "css/images/payment.png";
                            break;
                        case "CABT08":
                            jsonArr[i].msgIconImg = "css/images/refund.png";
                            break;
                        default:
                            jsonArr[i].msgIconImg = "css/images/Receivables.png";
                            break;
                    }
                    jsonArr[i].EntryTimeText = formatedate3(jsonArr[i].EntryTime,"D1");
                    newList.push(EntryID);
                    jsonNew.push(jsonArr[i]);
                }
            }
            oldList = oldList.concat(newList);
            if(jsonArr.length < 9){
                $(obj).find(".mouthFooter").attr("showFlag","false");
                $(obj).find(".mouthFooter").addClass("uhide");
            }
            var htmllist = zy_tmpl(BillTerms, jsonNew);
            htmllist = $(htmllist);
            $(obj).find(".mouthBody").append(htmllist);
            loadingMsg.HideMsg();
        } else {
            noticeMsg.ShowPromptMsg(result.ResultMsg);
        }
    }, function(result) {
        resetBV(0);
        loadingMsg.HideMsg();
    });
}

$("#tuikuanBtn").on("click",function(){
    setOpenWidgetOrHtml("TT02", widgetAppID, "AccountRefund", "AccountRefund");
})

function openDetail (EntryType, RefObjID) {
    switch(EntryType){
        case "CABT02":
        case "CABT03":
        case "CABT04":
        case "CABT06":
        case "CABT07":
            setLocVal("AppToDetail","true");
            setLocVal("PurchaserTenantID", getLocVal("CurrentTenantID"));
            setLocVal("OrderDetailID",RefObjID);
            setOpenWidgetOrHtml("TT02", widgetAppID, "OrderDetail", "OrderDetail");
            // openWin("OrderDetail","../OrderDetail.html");
            break;
        case "CABT05":
        case "CABT08":
            setLocVal("AppToRefund","true");
            setLocVal('RReqID', RefObjID);
            setOpenWidgetOrHtml("TT02", widgetAppID, "RefundApplicationDetails", "RefundApplicationDetails");
            break;
        default:
            break;
    }
}
