var MenuData = {
    ServiceJson : function() {
        var modelJson = [{
            "Name" : "买家交易服务",
            "SuItemCode" : "ITM000007",
            "MarketType" : "MT01",
            "LogoSrc" : "css/images/menulogo/purchaseTrade.png",
            "Order" : 3
        }, {
            "Name" : "卖家交易服务",
            "SuItemCode" : "ITM000006",
            "MarketType" : "MT01",
            "LogoSrc" : "css/images/menulogo/purchaseTrade.png",
            "Order" : 4
        }, {
            "Name" : "买家综合服务",
            "SuItemCode" : "ITM000013",
            "MarketType" : "MT02",
            "LogoSrc" : "css/images/menulogo/purchaseMain.png",
            "Order" : 1
        }, {
            "Name" : "卖家综合服务",
            "SuItemCode" : "ITM000014",
            "MarketType" : "MT02",
            "LogoSrc" : "css/images/menulogo/purchaseMain.png",
            "Order" : 2
        }];
        return modelJson;
    },
    /*PrivCode PC端的菜单标识
     * Code 在移动端的标识，目前为空，也没怎么用。
     * Title 显示的菜单名称
     * SuItemCode 所属的服务的标识
     * MenuLogoURL 菜单的图标
     * MenuFunction 点击菜单执行的方法
     * Show 该菜单是否能显示（空：显示，uhide：不显示）
     * HomeShow 该菜单是否在首页显示（1:显示，0：不显示）
     * Order 菜单的排序（数字）
     * AppOnly 是否是APP端专属菜单（1:是，0：否）
     */
    MenuJson : function() {
        //MenuFunction:对应的点击事件在MenuFunction中定义
        var modelJson = [
        //石油买家综合服务
        {
            "PrivCode" : "FUN51600",
            "Code" : "",
            "Title" : "我的订单",
            "SuItemCode" : "ITM000013",
            "MenuLogoURL" : "css/images/menulogo/wodedingdan.png",
            "MenuFunction" : "MenuFunction.MFCompanyList(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 1,
            "AppOnly" : "0"
        }, {
            "PrivCode" : "FUN51601",
            "Code" : "",
            "Title" : "我的客存",
            "SuItemCode" : "ITM000013",
            "MenuLogoURL" : "css/images/menulogo/wodekecunBuyer.png",
            "MenuFunction" : "MenuFunction.MFMyStorageList(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 2,
            "AppOnly" : "0"
        }, {
            "PrivCode" : "FUN51602",
            "Code" : "",
            "Title" : "我的提货申请",
            "SuItemCode" : "ITM000013",
            "MenuLogoURL" : "css/images/menulogo/tihuoshenqingBuyer.png",
            "MenuFunction" : "MenuFunction.MFDeliveryList(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 3,
            "AppOnly" : "0"
        }, {
            "PrivCode" : "FUN51601",
            "Code" : "",
            "Title" : "客存对账",
            "SuItemCode" : "ITM000013",
            "MenuLogoURL" : "css/images/menulogo/kecunduizhangBuyer.png",
            "MenuFunction" : "MenuFunction.MFAccountCheckList(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 4,
            "AppOnly" : "0"
        },
        //石油卖家综合服务
        {
            "PrivCode" : "FUN51702",
            "Code" : "",
            "Title" : "提货申请管理",
            "SuItemCode" : "ITM000014",
            "MenuLogoURL" : "css/images/menulogo/tihuoshenqingSeller.png",
            "MenuFunction" : "MenuFunction.MFDeliveryListSeller(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 1,
            "AppOnly" : "0"
        },{
            "PrivCode" : "FUN51705",
            "Code" : "",
            "Title" : "提油验证",
            "SuItemCode" : "ITM000014",
            "MenuLogoURL" : "css/images/menulogo/tiyouyanzheng.png",
            "MenuFunction" : "MenuFunction.MFPasswordExtraction(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 2,
            "AppOnly" : "0"
        }, {
            "PrivCode" : "FUN51700",
            "Code" : "",
            "Title" : "合同管理",
            "SuItemCode" : "ITM000014",
            "MenuLogoURL" : "css/images/menulogo/jiaoyi.png",
            "MenuFunction" : "MenuFunction.MFCompanyListSeller(this)",
            "Show" : "uhide",
            "HomeShow" : "1",
            "Order" : 3,
            "AppOnly" : "0"
        }, {
            "PrivCode" : "FUN51701",
            "Code" : "",
            "Title" : "客存对账管理",
            "SuItemCode" : "ITM000014",
            "MenuLogoURL" : "css/images/menulogo/kecunduizhangSeller.png",
            "MenuFunction" : "MenuFunction.MFMyStorageListSeller(this)",
            "Show" : "uhide",
            "HomeShow" : "1",
            "Order" : 4,
            "AppOnly" : "0"
        }, {
            "PrivCode" : "FUN51703",
            "Code" : "",
            "Title" : "已售未提",
            "SuItemCode" : "ITM000014",
            "MenuLogoURL" : "css/images/menulogo/tegong.png",
            "MenuFunction" : "MenuFunction.MFSoldListSeller(this)",
            "Show" : "uhide",
            "HomeShow" : "1",
            "Order" : 5,
            "AppOnly" : "0"
        },
        //买家交易服务
        {
            "PrivCode" : "FUN50101",
            "Code" : "",
            "Title" : "当前草稿订单",
            "SuItemCode" : "ITM000007",
            "MenuLogoURL" : "css/images/menulogo/dingdan.png",
            "MenuFunction" : "MenuFunction.MFDraftOrder(this)",
            "Show" : "uhide",
            "HomeShow" : "1",
            "Order" : 2,
            "AppOnly" : "0"
        }, {
            "PrivCode" : "FUN50100",
            "Code" : "",
            "Title" : "已买到货品",
            "SuItemCode" : "ITM000007",
            "MenuLogoURL" : "css/images/menulogo/yimaidaohuopin.png",
            "MenuFunction" : "MenuFunction.MFOrderItemChild(this)",
            "Show" : "uhide",
            "HomeShow" : "1",
            "Order" : 1,
            "AppOnly" : "0"
        }, {
            "PrivCode" : "FUN50201",
            "Code" : "",
            "Title" : "客户结算记录",
            "SuItemCode" : "ITM000007",
            "MenuLogoURL" : "css/images/menulogo/jiesuan.png",
            "MenuFunction" : "MenuFunction.MFBalanceOrderList(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 3,
            "AppOnly" : "0"
        }, {
            "PrivCode" : "FUN50103",
            "Code" : "",
            "Title" : "退货通知",
            "SuItemCode" : "ITM000007",
            "MenuLogoURL" : "css/images/menulogo/tuihuotongzhi.png",
            "MenuFunction" : "MenuFunction.MFReturnGoodsManage(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 4,
            "AppOnly" : "0"
        },
        //卖家交易服务
        {
            "PrivCode" : "FUN50305",
            "Code" : "",
            "Title" : "代客下单",
            "SuItemCode" : "ITM000006",
            "MenuLogoURL" : "css/images/menulogo/daikexiadan.png",
            "MenuFunction" : "MenuFunction.MFValetOrders(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 4,
            "AppOnly" : "0"
        },{
            "PrivCode" : "FUN50301",
            "Code" : "",
            "Title" : "待确认订单管理",
            "SuItemCode" : "ITM000006",
            "MenuLogoURL" : "css/images/menulogo/NSOrder.png",
            "MenuFunction" : "MenuFunction.MFOrderSellerNS(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 1,
            "AppOnly" : "0"
        },{
            "PrivCode" : "FUN50302",
            "Code" : "",
            "Title" : "物流信息管理",
            "SuItemCode" : "ITM000006",
            "MenuLogoURL" : "css/images/menulogo/wuliuguanli.png",
            "MenuFunction" : "MenuFunction.MFValetOrders(this)",
            "Show" : "uhide",
            "HomeShow" : "1",
            "Order" : 2,
            "AppOnly" : "0"
        },{
            "PrivCode" : "FUN50303",
            "Code" : "",
            "Title" : "已确认订单管理",
            "SuItemCode" : "ITM000006",
            "MenuLogoURL" : "css/images/menulogo/ISOrder.png",
            "MenuFunction" : "MenuFunction.MFOrderSellerIS(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 3,
            "AppOnly" : "0"
        }];
        return modelJson;
    },
    MenuJsonAll : function() {
        var modelJson = [{
            "PrivCode" : "",
            "Code" : "MenuAll",
            "Title" : "全部",
            "SuItemCode" : "ITM000013",
            "MenuLogoURL" : "css/images/menulogo/menuAll.png",
            "MenuFunction" : "MenuFunction.MFAllMenu(this)",
            "Show" : "",
            "HomeShow" : "1",
            "Order" : 1000,
            "AppOnly" : "1"
        }];
        return modelJson;
    }
}

//各个菜单的点击事件
var MenuFunction = {
    MFCompanyList : function(obj) {
        if (getLocVal("OpeningWidget") == "" || getLocVal("OpeningWidget") == "N") {
            setLocVal("OpeningWidget", "Y");
            setOpenWidgetOrHtml("TT02", widgetAppID, "ContractList", "", $(obj).find('.shanghuMenuList_icon'));
        }
    },
    MFMyStorageList : function(obj) {
        if (getLocVal("OpeningWidget") == "" || getLocVal("OpeningWidget") == "N") {
            setLocVal("OpeningWidget", "Y");
            setOpenWidgetOrHtml("TT02", widgetAppID, "MyStorage", "", $(obj).find('.shanghuMenuList_icon'));
        }
    },
    MFPasswordExtraction : function(obj) {
        if (getLocVal("OpeningWidget") == "" || getLocVal("OpeningWidget") == "N") {
            setLocVal("OpeningWidget", "Y");
            setOpenWidgetOrHtml("TT02", widgetAppID, "PasswordExtraction", "", $(obj).find('.shanghuMenuList_icon'));
        }
    },
    MFDeliveryList : function(obj) {
        if (getLocVal("OpeningWidget") == "" || getLocVal("OpeningWidget") == "N") {
            setLocVal("OpeningWidget", "Y");
            setOpenWidgetOrHtml("TT02", widgetAppID, "DeliveryList", "", $(obj).find('.shanghuMenuList_icon'));
        }
    },
    MFAccountCheckList : function(obj) {
        if (getLocVal("OpeningWidget") == "" || getLocVal("OpeningWidget") == "N") {
            setLocVal("OpeningWidget", "Y");
            setOpenWidgetOrHtml("TT02", widgetAppID, "AccountCheckList", "", $(obj).find('.shanghuMenuList_icon'));
        }
    },
    MFCompanyListSeller : function(obj) {
        warningMsg.ShowPromptMsg("功能暂未开放，敬请期待！");
    },
    MFMyStorageListSeller : function(obj) {
        warningMsg.ShowPromptMsg("功能暂未开放，敬请期待！");
    },
    MFDeliveryListSeller : function(obj) {
        if (getLocVal("OpeningWidget") == "" || getLocVal("OpeningWidget") == "N") {
            setLocVal("OpeningWidget", "Y");
            setOpenWidgetOrHtml("TT02", widgetAppID, "DeliveryListSeller", "", $(obj).find('.shanghuMenuList_icon'));
        }
    },
    MFSoldListSeller : function(obj) {
        warningMsg.ShowPromptMsg("功能暂未开放，敬请期待！");
    },
    MFDraftOrder : function(obj) {
        openWin('DraftOrderList', 'DraftOrderList.html?TenantID=' + TenantID + '&RootTenantID=' + RootTenantID + '&PartnerID=' + PartnerID + "");
    },
    MFOrderItemChild : function(obj) {
        setLocVal("Order_companyName", PartnerName);
        setLocVal("Order_TenantID", TenantID);
        setLocVal("Order_KPICode", "all");
        openWin('MyOrder', 'MyOrder.html');
    },
    MFOrderSellerNS : function(obj) {
        setLocVal("Order_companyName", $(obj).find(".shanghuMenuList_title").html());
        setLocVal("Order_TenantID", TenantID);
        setLocVal("Order_KPICode", "all");
        setLocVal("Order_StateSort", "NS");
        openWin('MyOrderSeller', 'MyOrderSeller.html');
    },
    MFOrderSellerIS : function(obj) {
        setLocVal("Order_companyName", $(obj).find(".shanghuMenuList_title").html());
        setLocVal("Order_TenantID", TenantID);
        setLocVal("Order_KPICode", "all");
        setLocVal("Order_StateSort", "IS");
        openWin('MyOrderSeller', 'MyOrderSeller.html');
    },
    MFBalanceOrderList : function(obj) {
        openWin('BalanceOrderList', 'BalanceOrderList.html');
    },
    MFReturnGoodsManage : function(obj) {
        openWin('ReturnGoodsManage', 'ReturnGoodsManage.html');
    },
    //石油二期新增
    MFMyGoodsList : function(obj) {
        setLocVal("Order_companyName", PartnerName);
        setLocVal("Order_TenantID", TenantID);
        setLocVal("Order_KPICode", "all");
        openWin('MyOrder', 'MyOrder.html');
    },
    MFValetOrders : function(obj) {
        if (getLocVal("OpeningWidget") == "" || getLocVal("OpeningWidget") == "N") {
            setLocVal("OpeningWidget", "Y");
            setOpenWidgetOrHtml("TT02", widgetAppID, "ValetOrders", "", $(obj).find('.shanghuMenuList_icon'));
        }
    },
    MFAllMenu : function(obj) {
        openWin('AllService', 'AllService.html');
    }
}