var pageIndex = 1;
var pageSize = 10;
var type = "";
var mindex = "";

var loadingMsg = new SinochemLoadingMsg();
appcan.ready(function() {
    setLocVal("PurchaserTenantID", getLocVal("CurrentTenantID"));
    type = getParamVal("type");
    mindex = getParamVal("mindex");
    if (getLocVal("Selectpindex") == mindex && $("#orderlist").html() == "") {
        getData(true);
    }
    var pagearry = strToJson(getLocVal("pagearry"));
    for (var i in pagearry) {
        $("#TapMenu").append("<div>" + pagearry[i].KPIName + "</div>");
    }
    appcan.window.subscribe("GetOrderData", function(index) {
        if (index == mindex && $("#orderlist").html() == "") {
            getData(true);
        }
    });
    
    appcan.window.subscribe("ReloadOrderData", function(index) {
        if (index == mindex) {
            reloadData();
        }
    });
    
    appcan.window.subscribe("MenuControl", function(val) {
        var valarry = val.split(',');
        if (valarry[1] == mindex) {
            MenuControl(valarry[0]);
        }
    });
    $("#TapMenu").find("div").each(function(index, obj) {
        $(obj).click(function() {
            $("#TapMenu div").removeClass("active");
            $(obj).addClass("active");
            MenuControl("N");
            ueScript("MyOrder", "ChildChangeTap(" + index + ")");
        });
    });
    setPageBounce(2, reloadData, getNextData);
    window.onorientationchange = window.onresize = function() {
        calculateSize();
    }
});

function MenuControl(control) {
    $("#TapMenu").find("div").removeClass("active");
    $("#TapMenu").find("div").eq(mindex).addClass("active");
    if (control == "Y") {
        var sheight = $(document.body).scrollTop();
        $("#TapMenu").css("top", sheight);
        uexWindow.setWindowScrollbarVisible(false);
        uexWindow.setBounce(0);
        $("#TapMenu").removeClass("uhide");
        $("#TapMenu").removeClass("slideOutUp");
        $("#TapMenu").addClass("slideInDown");
        loading();
        $("#zhezhao").on('touchstart', function(e) {
            ueScript("MyOrder", "menuControl('N')");
        });
    } else {
        $("#TapMenu").removeClass("slideInDown");
        $("#TapMenu").addClass("slideOutUp");
        setTimeout(function() {
            delloading();
        }, 500);
        uexWindow.setBounce(1);
    }
}

function getData(isInit) {
    if (isInit) {
        loadingMsg.ShowLoadingMsg(msg_LoadPage);
    }
    var CallData = {
        LType : "L013",
        StrOptions : {
            "TenantID" : getLocVal("Order_TenantID"),
            "KpiCode" : getParamVal("type"),
            "PageSize" : pageSize,
            "PageIndex" : pageIndex
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        var json = result.Data;
        if (isInit == undefined) {
            if (pageIndex == 1) {
                resetBV(0);
            } else {
                resetBV(1);
            }
        }
        if (json.Items.length <= 0) {
            loadingMsg.HideMsg();
            listNoData($("#orderlist"), isInit, pageIndex, "暂无相关数据");
            return;
        }
        for (var i in json.Items) {
            json.Items[i].CreatedAt = formatedate2(json.Items[i].CreatedAt);
            json.Items[i].FeeAmount = formatMoney(json.Items[i].FeeAmount + "");
            if(parseFloat(json.Items[i].MtrlAmount) == 0 && json.Items[i].PriceState != "CS90"){
                json.Items[i].MtrlAmount = "--";
            }else{
                json.Items[i].MtrlAmount = formatMoney(json.Items[i].MtrlAmount);
            }
            json.Items[i].OrderAmount = formatMoney(json.Items[i].OrderAmount);
            if (json.Items[i].ThumbnailURL == null) {
                json.Items[i].ThumbnailURL = "css/images/default.png"
            }
            for (var j in json.Items[i].Details) {
                if (json.Items[i].Details[j].ThumbnailURL == null) {
                    json.Items[i].Details[j].ThumbnailURL = "css/images/default.png";
                }
            }
            var orderItemSP = getHtmlContent("orderItemSP");
            var GoodsList = zy_tmpl(orderItemSP, json.Items[i].Details);
            json.Items[i].GoodsCount = json.Items[i].Details.length;
            json.Items[i].GoodsList = GoodsList;
        }
        var tempOne = getHtmlContent("orderItemOne");
        var tempSome = getHtmlContent("orderItemSome");
        var htmllist = "";
        for (var i in json.Items) {
            var pushData = [];
            pushData.push(json.Items[i]);
            //if(json.Items[i].Details.length>1){
            htmllist += zy_tmpl(tempSome, pushData);
            //}
            // else{
            // pushData[0].DeliverPlace=pushData[0].Details[0].DeliverPlace;
            //htmllist+=zy_tmpl(tempOne, pushData);
            //}
        }
        if (pageIndex == 1) {
            $("#orderlist").html(htmllist);
        } else {
            $("#orderlist").append(htmllist);
        }
        $(".imgContainer").each(function() {
            $(this).find(".itemConent").addClass("uhide");
            $(this).find(".itemConent").eq(0).removeClass("uhide");
        });
        $(".expanddiv").each(function() {
            if ($(this).attr("GoodsCount") == "1") {
                $(this).addClass("uhide");
            }
        });
        loadingMsg.HideMsg();

    }, function(result) {
        if (isInit == undefined) {
            if (pageIndex == 1) {
                resetBV(0);
            } else {
                resetBV(1);
            }
        }
        var errorHtml = GetAjaxRequestFaillHtml("getData(true)", "");
        $("#orderlist").html(errorHtml);
        loadingMsg.HideMsg();
    });
}

function ExpandChild(obj) {
    if ($(obj).find(".UpAll").hasClass("expand")) {
        $(obj).find(".ControlImg").removeClass("DownAllImg");
        $(obj).find(".ControlImg").addClass("UpAllImg");
        $(obj).find(".UpAll").removeClass("expand");
        $(obj).find(".UpAll").html("展开全部");
        $(obj).parents(".OrderItem").find(".itemConent").addClass("uhide");
        $(obj).parents(".OrderItem").find(".itemConent").eq(0).removeClass("uhide");
    } else {
        $(obj).find(".ControlImg").removeClass("UpAllImg");
        $(obj).find(".ControlImg").addClass("DownAllImg");
        $(obj).find(".UpAll").addClass("expand");
        $(obj).find(".UpAll").html("收起全部");
        $(obj).parents(".OrderItem").find(".itemConent").removeClass("uhide");
    }

}

function reloadData() {
    loadingMsg.HideMsg();
    pageIndex = 1;
    getData();
}

function getNextData() {
    beforeGetNextData();
    pageIndex++;
    getData();
}

function openOrderDetail(OrderID, ResID, OrderState) {
    setLocVal('OrderDetailID', OrderID);
    setLocVal('ResID', ResID);
    switch(OrderState) {
    case "SS01":
    case "SS02":
        setLocVal("OrderWidgetFlag","false");
        openWin("OrderBudget", "OrderBudget.html");
        break;
    default:
        setLocVal("OrderWidgetFlag","false");
        // openWin("OrderDetail", "OrderDetail.html");
        openWin("OrderBudget", "OrderBudget.html");
        break;
    }
}
