var allNewsPageCount = 0;
var newsPageIndex = 1;
var mySwiperMarket = null;
var marketCount = 0;

$("#ceshigonggao").on("click",function(){
    getNewsPage('AAA00753','0962D897-7452-48D6-899C-4537D7074009',newsPageIndex);
})

function IsNews (MarketID) {
    var CallData = {
        LType : 'L135',
        StrOptions : {
            "TenantID":getLocVal("CurrentTenantID"),
            "MarketID": MarketID || getLocVal("CurrentMarketID"),
            "PageIndex":newsPageIndex.toString(),
            "PageSize":"1"
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        console.log(result);
        if (result && result.Data && result.Data.Items) {
            //打开公告弹出框
            ueScript("","opengetNews()");
        }
    }, function(result) {
        noticeMsg.ShowPromptMsg("数据加载失败，请稍后重试！");
    });
}

//获取最新的公告
function getNewsPage (MarketID) {
    var CallData = {
        LType : 'L135',
        StrOptions : {
            "TenantID":getLocVal("CurrentTenantID"),
            "MarketID": MarketID || getLocVal("CurrentMarketID"),
            "PageIndex":newsPageIndex.toString(),
            "PageSize":"1"
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        console.log(result);
        if (result && result.Data && result.Data.Items) {
            allNewsPageCount = result.Data.ResultCount;
            var objData = result.Data.Items[0];
            addClickCount(objData.ArID);
            $("#newsName").removeClass("uhide");
            $(".newsTitle").html(objData.ArName);
            $(".newsContent").html(objData.ArContentBlob);
            $("#newsName").html(objData.ArClassName);
            $(".currentPage").html(newsPageIndex);
            $(".allPage").html(allNewsPageCount);
            $(".newsContent a").on("click",function(){
                return false;
            });
            $(".provBtn").removeClass("provBtnHover");
            $(".nextBtn").removeClass("nextBtnHover");
            if(newsPageIndex == 1 || newsPageIndex == 0){
                $(".provBtn").addClass("provBtnHover");
            }
            if(newsPageIndex == allNewsPageCount){
                $(".nextBtn").addClass("nextBtnHover");
            }
            if(mySwiperMarket == null && marketCount > 2){
                mySwiperMarket = new Swiper('#MarketContainer', {
                    // 如果需要分页器
                    pagination: '.paginationMarket'
                })
            }
        }else{
            if(!$(".zhezhaoBox").hasClass("uhide")){
                allNewsPageCount = 0;
                newsPageIndex = 0;
                $(".newsTitle").html("重要公告");
                $(".newsContent").html("该市场暂无公告");
                $("#newsName").addClass("uhide");
                $(".currentPage").html(newsPageIndex);
                $(".allPage").html(allNewsPageCount);
                $(".newsContent a").on("click",function(){
                    return false;
                });
                $(".provBtn").removeClass("provBtnHover");
                $(".nextBtn").removeClass("nextBtnHover");
                if(newsPageIndex == 1 || newsPageIndex == 0){
                    $(".provBtn").addClass("provBtnHover");
                }
                if(newsPageIndex == allNewsPageCount){
                    $(".nextBtn").addClass("nextBtnHover");
                }
            }
        }
    }, function(result) {
        noticeMsg.ShowPromptMsg("数据加载失败，请稍后重试！");
    });
}

//关闭公告
$(".closeNewsBtn").bind("click",function(){
    var CurrentMarketID = $(".marketItemSelect").attr("marketID");
    closeNews(getLocVal("CurrentTenantID"),CurrentMarketID);
})
function closeNews (TenantID,MarketID) {
    var ReadArtDT = getNowDateTime();
    var CallData = {
        LType : 'L136',
        StrOptions : {
            "TenantID":TenantID,
            "MarketID":MarketID,
            "ReadArtDT":ReadArtDT
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        if (result) {
            ueScript("","closegetNews()");
        }
    }, function(result) {
        noticeMsg.ShowPromptMsg("数据加载失败，请稍后重试！");
    });
}

//上一页
$(".provBtn").on("click",function(){
    if(newsPageIndex > 1){
        newsPageIndex--;
        var CurrentMarketID = $(".marketItemSelect").attr("marketID");
        getNewsPage(CurrentMarketID);
    }
    // else{
        // alert("当前为第一条公告");
    // }
})

//下一页
$(".nextBtn").on("click",function(){
    if(newsPageIndex < allNewsPageCount){
        newsPageIndex++;
        var CurrentMarketID = $(".marketItemSelect").attr("marketID");
        getNewsPage(CurrentMarketID);
    }
    // else{
        // alert("当前为最后一条公告");
    // }
})

function delloadingNews() {
    if ($('.zhezhaoNews').length > 0) {
        $('.zhezhaoNews').remove();
    }
    $('.spinner').remove();
    $('#loading').remove();
}

function addmotaiNews() {
    delloading();
    $("<div class='zhezhaoNews' id='zhezhaoNews'></div>").appendTo(document.body);
    var bheight = $(document).height();
    $(".zhezhaoNews").css("height", bheight);
}

//增加公告浏览次数
function addClickCount (ArID) {
    var CallData = {
        DID : ArID,
        DType : "D018",
        StrOptions : {
            
        }
    };
    callAjaxService("POST", "QueryDetail", CallData, true, function(result) {
        if (result && result.ResultCode == "0") {
            console.log("浏览次数增加");
        }
    });
}
        
//获取市场列表
function getMarketList(cb){
    var CallData = {
        LType : "L105",
        StrOptions : {
            "TenantID" : getLocVal("CurrentTenantID")
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        var markethtml = "";
        if(result && result.Data && result.Data.length > 1){
            var marketData = result.Data;
            var marketItemSelect = "";
            for(var i in marketData){
                if(marketData[i].MarketID == getLocVal("CurrentMarketID")){
                    marketItemSelect = "marketItemSelect";
                }else{
                    marketItemSelect = "";
                }
                if(i % 2 == 0){
                    markethtml += '<div class="swiper-slide">';
                }
                markethtml += '<div class="marketItem ub-f1 ub ub-ac ub-pc divmore '+marketItemSelect+'" marketID="'+marketData[i].MarketID+'">'
                                +marketData[i].MarketName
                            +'</div>'
                if((parseInt(i) + 1) % 2 == 0 || ((parseInt(i) + 1) == marketData.length && (parseInt(i) + 1) % 2 != 0)){
                    markethtml += '</div>';
                }
            }
            marketCount = result.Data.length;
            $("#MarketContainer").removeClass("uhide");
            $(".newsDividingLine").removeClass("uhide");
        }else{
            markethtml = '<div class="swiper-slide">'
                            +'<div class="marketItem ub-f1 ub ub-ac ub-pc divmore marketItemSelect" marketID="'+result.Data[0].MarketID+'">'
                                +result.Data[0].MarketName
                            +'</div>'
                    +'</div>'
            marketCount = result.Data.length;
            $("#MarketContainer").addClass("uhide");
            $(".newsDividingLine").addClass("uhide");
        }
        $("#MarketContainer .swiper-wrapper").html(markethtml);
        $("#MarketContainer .marketItem").on("click",function(){
            newsPageIndex = 1;
            $(this).siblings().removeClass("marketItemSelect");
            $(this).parent().siblings().find(".marketItem").removeClass("marketItemSelect");
            $(this).addClass("marketItemSelect");
            var CurrentMarketID = $(this).attr("marketID");
            getNewsPage(CurrentMarketID);
        })
        if(cb){
            cb(getLocVal("currentMarket"));
        }
    }, function(result) {
    });
}
