/***************************公共脚本***********************************************/
/*2015/06/29整理*/

/*----------------公共变量-----------------------*/
/*是否在手机上运行*/
var isPhone = (window.navigator.platform != "Win32");

/*客户端是否为Android系统*/
var isAndroid = (window.navigator.userAgent.indexOf('Android') >= 0) ? true : false;
/*客户端是否为iPad系统*/
var isiPad = window.navigator.userAgent.indexOf('iPad') >= 0;
/*客户端是否为IOS系统*/
var isIOS = window.navigator.userAgent.indexOf('iPhone') >= 0 || window.navigator.userAgent.indexOf('iPad') >= 0 || window.navigator.userAgent.indexOf('iPod') >= 0;

/*MAS服务IP地址*/
var masipConfig = "https://mam.esinochem.com:48443/ProdServer/aaabw10091/public/EBSMasConfig";
var masip = "https://mam.esinochem.com:48443/ProdServer/aaabw10091/public/EBSMasProd";
//var masip = "http://10.143.0.123:18081/aaabw10072/public/EBSMas";
//var masip = "http://localhost:6380/EBSMas";

var appID = "aaabw10091";
var widgetAppID = "aaanc10027";
var widgetAppIDYX = "aaanc10079";
var appUpdateID = "aaanc10057";
var EBSSource = "EBSApp" + appID;

//是否用MAS的方式进行版本判断?登录页面弹出提示：按照EMM配置的执行,弹出EMM的提示。
//**只有生产环境设置为true
var EBSCheckVersionMAS = false;
//是否需要通过配置的MAS获取业务MASIP地址,生产环境为true;
var isNeedConfigMasip = true;
//是否进行app升级判断
var isUpdateAPP=true;

//是否是H5或者APP（调用后台接口时需要传递此参数）
var ChannelNo = "APP";

//是否进行token验证
var isEMMToken = true;


/**
 * 通用页面加载中提示信息
 */
var msg_LoadPage = "数据加载中...";

var loadFailMsg = "网络不给力，请稍后重试";

var noData_html = '<div id="noDataDiv" class="ub SmallFont ub-pc Nodata"><div class="ub ub-f1 ub-ac"><div class="noDataLine"></div></div><div>没有更多了</div><div class="ub ub-f1 ub-ac"><div class="noDataLine"></div></div></div>';

/*----------------公共方法-----------------------*/
/**
 * 检查附件后缀名
 */
function checkFileExtend(name){
    console.log(name);
    var index = name.lastIndexOf(".");
    if(index < 0){
      return false;
    }
    var ext = name.substring(index+1).toLowerCase();
    if(ext == "gif" || ext == "jpg" || ext == "jpeg" || ext == "bmp" || ext == "png" || ext == "doc" || ext == "docx" || ext == "xls" || ext == "xlsx" || ext == "ppt" || ext == "pptx" || ext == "pdf" || ext == "txt" || ext == "xml"){
       return true;
    }
    return false;
}

/**
 * 调用MAS接口获取或处理数据
 * CallType：GET或POST
 * CallServiceName:调用接口的方法
 * CallData：请求的参数
 * isDataJson:使用GET方法请求返回的数据格式（true：json,false：text）
 * successCallback：请求成功的回调函数
 * errorCallback：请求失败的回调函数
 */
function callAjaxService(CallType, CallServiceName, CallData, isDataJson, successCallback, errorCallback) {
    if (isNeedConfigMasip && isIOS) {
        GetMasipConfig(function(masipUrl) {
            callAjaxServiceMas(masipUrl, CallType, CallServiceName, CallData, isDataJson, successCallback, errorCallback);
        });
    } else {
        callAjaxServiceMas(masip, CallType, CallServiceName, CallData, isDataJson, successCallback, errorCallback);
    }
}

//masip 通过传值获得
function callAjaxServiceMas(MasipUrl, CallType, CallServiceName, CallData, isDataJson, successCallback, errorCallback) {
    var userCode = getLocVal("UserCode");
    var TenantID = getLocVal("CurrentTenantID");
    if (userCode == "") {
        userCode = "wangzf3";
    }
    if (CallData["UserCode"] != "" && CallData["UserCode"] != undefined) {
        userCode = CallData["UserCode"];
    }
    if (CallData["TenantID"] != "" && CallData["TenantID"] != undefined) {
        TenantID = CallData["TenantID"];
    }
    if (CallData["StrOptions"]["TenantID"] != "" && CallData["StrOptions"]["TenantID"] != undefined) {
        TenantID = CallData["StrOptions"]["TenantID"];
    }
    CallData["UserCode"] = userCode;
    CallData["AppID"] = appID;
    CallData["TenantID"] = TenantID;
    CallData["ChannelNo"] = ChannelNo;
    CallData["StrOptions"]["UserCode"] = userCode;
    CallData["StrOptions"]["SourceCode"] = EBSSource;
    CallData["StrOptions"]["ChannelNo"] = ChannelNo;
    CallData["StrOptions"]["TenantID"] = TenantID;
    CallData["StrOptions"]["AppID"] = appID;
    var Type = CallType.toUpperCase() == 'GET' ? 'GET' : 'POST';
    if(Type == "GET"){
        CallData["StrOptions"] = jsonToStr(CallData["StrOptions"]);
    }
    if(isEMMToken == true){
        var EMMToken = getLocVal("EMMToken") || "123456";
    }else{
        var EMMToken = "public";
    }
    appcan.request.ajax({
        type : Type,
        url : MasipUrl.replace("public",EMMToken) + '/' + CallServiceName,
        data : CallData,
        timeout : 45000,
        // certificate : {
        // password : 'sinoxms123',
        // path : 'res://clientCertificate.p12'
        // },
        dataType : isDataJson ? 'json' : 'text',
        success : function(data) {
            if (data && data.status && data.status == 14504) {
                // new SinochemConfirmationMsg("", function() {
                    // if(isPhone){
                        uexWindow.alert('提示', "用户凭证已过期，请重新输入用户密码登录", '确定');
                        setLocVal("UserCode", "");
                        setLocVal("UserInfo", "");
                        setLocVal("FromType","");
                        setLocVal("LoginNumber","");
                        setLocVal("lockPass","");
                        setLocVal("GestureChengeFlag","");
                        setLocVal("ChangeBusinessmen", "");  
                        var Storage = window.localStorage;
                        Storage.clear();
                        setTimeout(function(){
                            uexWidgetOne.restart();
                        },1000);
                    // }
                // }, 1).ShowConfirmationMsg("", "用户凭证已过期，请重新输入用户密码登录");
                return; 
            }
            if (successCallback) {
                successCallback(data);
            }
        },
        error : function(xhr, type) {
            if (type == "timeout") {
                //showToast("数据请求超时,请检查您的网络链接！", 3000);
            }
            if (errorCallback) {
                errorCallback(xhr, type);
            }
        }
    });
}

function GetMasipConfig(cb) {
    var thismasip = masip;
    if (getLocVal("thismasip") != "") {
        thismasip = getLocVal("thismasip");
        if (cb) {
            cb(thismasip);
        }
    } else {
        //调用配置接口，获取业务数据调用的MASIP
        uexWidgetOne.cbGetCurrentWidgetInfo = function(opId, dataType, data) {
            var currVersion = "";
            if (dataType == 1) {
                var json = JSON.parse(data);
                currVersion = json.version;
            }
            var CallData = {
                CurrVersion : currVersion
            };
            appcan.request.ajax({
                type : 'POST',
                url : masipConfig + '/GetConfigMasip',
                data : CallData,
                timeout : 45000,
                dataType : 'json',
                success : function(data) {
                    if (data && data.Data) {
                        thismasip = data.Data.Masip;
                        setLocVal("thismasip", thismasip);
                        if (cb) {
                            cb(thismasip);
                        }
                    }
                },
                error : function(xhr, type) {
                    //noticeMsg.ShowPromptMsg("网络异常,请检查网络!");
                    if (cb) {
                        cb(thismasip);
                    }
                }
            });
        };
        uexWidgetOne.getCurrentWidgetInfo();
    }
}

/**
 * 获取指定的URL参数值
 * URL:http://www.quwan.com/index?name=tyler
 * 参数：paramName URL参数
 * 调用方法:getParam("name")
 * 返回值:tyler
 */
function getParamVal(parmname) {
    params = zy_parse();
    var returnval = "";
    if (params[parmname] != "undefined") {
        returnval = params[parmname];
    }
    return returnval;
}

function goHome() {
    if (isPhone) {
        if (isAndroid) {
            uexWindow.setReportKey(0, 1);
        }
        appcan.window.monitorKey(0, function() {
            var info = '{"category":["android.intent.category.HOME"]}';
            uexWidget.startApp(1, "android.intent.action.MAIN", info);
        });
    }
}

/**
 * 打开一个新窗口
 * 如果窗口名字相同，则会覆盖相同窗口名字的页面内容
 *  windName: (String类型) 必选 窗口名字，可为空，不能为"root"，若已经打开过该名 字的窗口，则直接跳转至该窗口。
 url:新窗口路径
 anim：动画ID

 最初使用uexWindow.open会造成页面缓存，打开一个已经打开过的页面会刷新闪烁
 所以使用了appcan较新的api：appcan.window.open
 */
function openWin(winName, url, anim, _type) {
    // uexWindow.open(winName, "0", url, ( anim ? anim : 10), "", "", "4", "275");
    appcan.window.open(winName, url, ( anim ? anim : 10), _type ? _type : 0);
}

function $$(id) {
    return document.getElementById(id);
}

/**
 * 关闭当前窗口
 * 若为浮动窗口直接关闭，若为主窗口，则同时会关闭在其上打开的所有 浮动窗口
 *  anim：关闭窗口动画，默认-1
 */
function closeWin(anim) {
    if (anim) {
        uexWindow.close(anim);
        return;
    }
    if (parseInt(anim) == 0) {
        uexWindow.close(anim);
        return;
    }
    uexWindow.close(-1);
}

/**
 * 在其他窗口中执行指定主窗口中的代码
 * @param String wn  需要执行代码窗口的名称
 * @param String scr 需要执行的代码
 */
function ueScript(wn, scr) {
    uexWindow.evaluateScript(wn, '0', scr);
}

/**
 * 在其他窗口中执行指定浮动窗口中的代码
 * @param String wn  需要执行代码浮动窗口所在的主窗口的名称
 * @param String pn  需要执行代码的浮动窗口的名称
 * @param String scr 需要执行的代码
 */
function ueppScript(wn, pn, scr) {
    uexWindow.evaluatePopoverScript(wn, pn, scr);
}

/***
 * 使弹动重置为初始位置
 * 设置弹动效果结束后显示的网页，一般在onBounceStateChange监听方法中调用该方法
 * @param String type 弹动的类型 0-顶部弹动  1-底部弹动
 */
function resetBV(type) {
    uexWindow.resetBounceView(type);
}

/**
 * 设置平台弹动效果(上拉加载，下拉刷新)
 * @param int sta   0=无弹动效果   1=默认弹动效果  2=设置图片弹动
 * @param Function downcb 下拉
 * @param Function upcb   上拖
 */
function setPageBounce(sta, downcb, upcb, isPullDownLoad) {
    if (sta == 0)
        return;
    var color = "#FFF";
    if (sta == 1) {
        var s = ['0', '0'];
        var str = '';
        uexWindow.onBounceStateChange = function(type, status) {
            if (downcb && type == 0 && status == 2)
                downcb();
            if (upcb && type == 1 && status == 2)
                upcb();
        }

        uexWindow.setBounce("1");

        if (downcb) {
            s[0] = '1';
            uexWindow.notifyBounceEvent("0", "1");
        }
        if (color) {
            uexWindow.showBounceView("0", color, s[0]);
        } else {
            uexWindow.showBounceView("0", "rgba(255,255,255,0)", s[0]);
        }

        if (upcb) {
            s[1] = '1';
            uexWindow.notifyBounceEvent("1", "1");
        }
        if (color) {
            uexWindow.showBounceView("1", color, s[1]);
        } else {
            uexWindow.showBounceView("1", "rgba(255,255,255,0)", s[1]);
        }
        //  uexWindow.showBounceView("1","rgba(255,255,255,0)",s[1]);
    }
    if (sta == 2) {
        uexWindow.onBounceStateChange = function(type, status) {
            if (downcb && type == 0 && status == 2)
                downcb();
            if (upcb && type == 1 && status == 2)
                upcb();
        }
        uexWindow.setBounce("1");

        if (downcb) {
            var hintText = "刷新";
            if (isPullDownLoad) {
                hintText = "加载";
            }
            var inJson1 = '{"loadingImagePath":"res://load.gif","imagePath":"res://arrow_down.png","textColor":"#999999","pullToReloadText":"下拉' + hintText + '","releaseToReloadText":"释放' + hintText + '","loadingText":"正在' + hintText + '，请稍等..."}'
            uexWindow.setBounceParams('0', inJson1);
            uexWindow.showBounceView('0', color, 1);
            uexWindow.notifyBounceEvent('0', 1);
        }
        if (upcb) {
            var inJson2 = '{"loadingImagePath":"res://load.gif","imagePath":"res://arrow_up.png","textColor":"#999999","pullToReloadText":"拖动加载","releaseToReloadText":"释放加载","loadingText":"正在加载，请稍等..."}'
            uexWindow.setBounceParams('1', inJson2)
            uexWindow.showBounceView('1', color, 1);
            uexWindow.notifyBounceEvent('1', 1);
        }
    }
}

/**
 *  隐藏弹动效果
 */
function hiddenPageBounce() {
    uexWindow.showBounceView("0", "#E6E6E6", "0");
    uexWindow.showBounceView("1", "#E6E6E6", "0");
}

/**
 *  显示弹动效果
 */
function showPageBounce() {
    uexWindow.showBounceView("0", "#E6E6E6", "1");
    uexWindow.showBounceView("1", "#E6E6E6", "1");
}

/**
 * 浮动窗口移动动画函数
 * @param String 横向移动位移
 * @param String 纵向移动位移
 * @param Function 动画结束后的回调函数
 */
function disShowAnim(dx, dy, cb) {
    uexWindow.beginAnimition();
    uexWindow.setAnimitionDuration('250');
    uexWindow.setAnimitionRepeatCount('0');
    uexWindow.setAnimitionAutoReverse('0');
    uexWindow.makeTranslation(dx, dy, '0');
    uexWindow.commitAnimition();
    if (cb)
        uexWindow.onAnimationFinish = cb;
}

/**
 * 显示加载框
 * @param String mes 显示的提示语
 * @param String t  毫秒数 窗口存在时间 有的话显示框不显示那个“圈”，并且在t时间后消失
 */
function showToast(mes, t) {
    //addmotai();
    //uexWindow.openPopover("ZheZhao",0,"warn_content.html","",400,0,'','','',0,100);
    uexWindow.toast( t ? '0' : '1', '5', mes, t ? t : 0);
    //if(t)
    //{
    //delloading();
    //}
}

/**
 * 手动关闭加载框
 */
function closeToast() {
    //delloading();
    //uexWindow.closePopover("ZheZhao")
    uexWindow.closeToast();
}

/**
 * 显示遮罩
 */
function loading(msg, ismotai) {
    //if (ismotai == 'true') {
    addmotai();
    //}
    // var target = document.body;
    // var loading = document.createElement("div");
    // loading.id = "loading";
    // loading.className = "spinbg";
    // var spinner = new Spinner().spin();
    // loading.appendChild(spinner.el);
    // //$("<div class='ulev-2 umar-a tx-c'>"+msg+"</div>").appendTo(loading);
    // target.appendChild(loading);
}

/**
 * 关闭遮罩
 */
function delloading() {
    if ($('.zhezhao').length > 0) {
        $('.zhezhao').remove();
    }
    $('.spinner').remove();
    $('#loading').remove();
}

function addmotai() {
    delloading();
    $("<div class='zhezhao' id='zhezhao'></div>").appendTo(document.body);
    var bheight = $(document).height();
    $(".zhezhao").css("height", bheight);
}


$(window).bind("orientationchang", function() {
    var bheight = $(document).height();
    $(".zhezhao").css("height", bheight);
});
$(window).bind("resize", function() {
    var bheight = $(document).height();
    $(".zhezhao").css("height", bheight);
});

function ListTouchStar(obj, isnoSelf) {
    if (isnoSelf && isnoSelf == "Y") {
        $(obj).parent("div").addClass("lstselect");
    } else {
        $(obj).addClass("lstselect");
    }
}

function ListTouchEnd(obj, isnoSelf) {
    if (isnoSelf && isnoSelf == "Y") {
        $(obj).parent("div").removeClass("lstselect");
    } else {
        $(obj).removeClass("lstselect");
    }
}

/**
 * alert 和 confirm 弹出框
 * @param String str 提示语
 * @param Function callback confirm的回调函数
 */
function alert(str, callback, f) {
    if (callback) {
        uexWindow.cbConfirm = function(opId, dataType, data) {
            if (data == 0)
                callback();
        }
        var btns = ['确定', '取消'];
        if (f) {
            btns = ['确定'];
        }
        uexWindow.confirm('提示', str, btns);
    } else
        uexWindow.alert('提示', str, '确定');
}

/**
 * 使用APPcan插件保存本地数据
 * @param String key  保存数据的key值
 * @param String value  保存的数据
 */
function setAppcanData(key, value) {
    try {
        if (uexWindow) {
            uexWindow.putLocalData(key, value);
        }
    } catch(ex) {

    }
}

/**
 * 使用APPcan插件获取本地数据
 * @param String key  保存数据的key值
 * @param String value  保存的数据
 */
function getAppcanData(key) {
    try{
        if (uexWindow) {
            return uexWindow.getLocalData(key);
        } else {
            return "";
        }
    }
    catch(ex){
        return "";
    }
}

/**
 * 保存本地数据
 * @param String key  保存数据的key值
 * @param String value  保存的数据
 */
function setLocVal(key, value) {
    window.localStorage[appID + "_" + key] = value;
    setAppcanData(appID + "_" + key, value);
}

/**
 * 根据key取localStorage的值
 * @param Stirng key 保存的key值
 */
function getLocVal(key) {
    var returnData="";
    var localData=window.localStorage[appID + "_" + key];
    if (localData) {
        if (localData != "") {
            returnData=localData;
        } else {
            var appcanData=getAppcanData(appID + "_" + key);
            if(appcanData&&appcanData!=""&&!isUndefinedData(appcanData)){
                alert("Key："+key+"，locstorage为空，appcanData不为空");
                window.localStorage[appID + "_" + key] = appcanData;
                returnData=appcanData;
            }
        }
    } else {
        var appcanData=getAppcanData(appID + "_" + key);
        if(appcanData&&appcanData!=""){
            window.localStorage[appID + "_" + key] = appcanData;
            returnData=appcanData;
        }
    }
    // console.log("returnData:"+key+"_"+returnData+'appcanData_'+appcanData+"localData_"+localData);
    if(localData==""){
        var appcanData=getAppcanData(appID + "_" + key);
        if(isUndefinedData(appcanData)){
           returnData="";
        }
    }
    return returnData;
}

function isUndefinedData(data) {
   var bresult=false;
   if(typeof(data)=="undefined"||data==undefined||data=="undefined"){
      bresult=true; 
   }
   return bresult;
}

/**
 * 清除缓存
 * @param Striong key  保存数据的key，如果不传清空所有缓存数据
 */
function clearLocVal(key) {
    if (key) {
        window.localStorage.removeItem(appID + "_" + key);
        setAppcanData(appID + "_" + key, "");
    }
    //else
    //window.localStorage.clear();
}

/**
 * 检查本地存储中是否包含某个键的值
 */
function checkKey(k) {
    return getLocVal(k) ? 1 : '';
}

/**
 *  将json格式的文本保存在本地
 */
function setStorJson(objName, json) {
    if (json)
        setLocVal(objName, JSON.stringify(json));
}

/**
 *  获取本地存储的json格式的文本
 */
function getStorJson(objName) {
    var ret = {};
    var str = getLocVal(objName);
    if (str)
        ret = JSON.parse(str);
    return ret;
}

/**
 * 图片预加载
 * @param String imgId div的ID，图片加载成功后给该div换背景
 * @param String imgUrl 图片路径
 */
function preloadImg(imgId, imgUrl) {
    var newImg = new Image();
    newImg.src = imgUrl;
    newImg.onload = function() {
        $$(imgId).style.backgroundImage = "url(" + newImg.src + ")";
        newImg = null;
    }
}

/**
 * 创建DOM节点
 * @param String t
 */
function createEle(t) {
    return document.createElement(t);
}

/**
 * 删除DOM节点
 * @param String id
 */
function removeNode(id) {
    var e = $$(id);
    if (e)
        e.parentElement.removeChild(e);
}

/**
 * 给DOM对象赋值innerHTML
 * @param String id 对象id或者对象
 * @param String html html字符串
 * @param String showstr 当html不存在时的提示语
 */
function setHtml(id, html, showstr) {
    var showval = isDefine(showstr) ? showstr : "";
    if ("string" == typeof (id)) {
        var ele = $$(id);
        if (ele != null) {
            ele.innerHTML = isDefine(html) ? html : showval;
        } else {
            alert("没有id为" + id + "的对象");
        }
    } else if (id != null) {
        id.innerHTML = isDefine(html) ? html : showval;
    }
}

/**
 * getJSON请求数据的错误回调函数
 * @param {Object} err 返回的错误对象
 */
function getJSONError(err) {
    $closeToast();
    resetBV(0);
    resetBV(1);
    if (err.message == 'network error!') {
        alert('网络未连接');
    } else if (err.message == 'json parse failed!') {
        alert('json解析失败');
    } else if (err.message == 'file does not exist!') {
        alert('文件不存在');
    } else if (err.message == 'read file failed!') {
        alert('文件读取错误');
    } else {
        alert('发现未知错误');
    }
}

/**
 * 输出log
 * @param String s 需要输出的信息
 * @param String a 添加的标注信息
 */
function logs(s, a) {
    if ( typeof s == 'object') {
        s = JSON.stringify(s);
    }
    a = a ? a : "";
    if (!isPhone) {
        console.log(a + s);
    } else {
        //生产环境代码，必须注释
        try{
            uexLog&&uexLog.sendLog(a + s);
        }
        catch(ex){
        }
    }
}

/**
 * 根据时间戳获取年、月、日
 * @param String str 时间戳
 * @param Boolean f 是否在原来的基础上*1000，true要*，false或不填就不*
 */
function getMakeTimes(str, f) {
    var t = (f) ? parseInt(str) : parseInt(str) * 1000;
    var d = new Date(t);
    var y = d.getFullYear();
    var m = setNum(d.getMonth() + 1);
    var d = setNum(d.d.getDate());
    return y + "-" + m + "-" + d;
}

/**
 * 根据时间戳获取年、月、日
 * @param String str 时间戳
 * @param Boolean f 是否在原来的基础上*1000，true要*，false或不填就不*
 */
function getMakeTimes2(str, f) {
    var t = (f) ? parseInt(str) : parseInt(str) * 1000;
    var d = new Date(t);
    var y = d.getFullYear();
    var m = setNum(d.getMonth() + 1);
    var d = setNum(d.d.getDate());
    var h = d.getHours() < 10 ? "0" + (d.getHours()) : (d.getHours());
    var n = d.getMinutes() < 10 ? "0" + d.getMinutes() : d.getMinutes();
    var s = d.getSeconds() < 10 ? "0" + d.getSeconds() : d.getSeconds();
    return y + "-" + m + "-" + d + " " + h + ":" + n + ":" + s;
}

function getNowDateTime() {
    var datetime = new Date();
    var year = datetime.getFullYear();
    var month = datetime.getMonth() + 1 < 10 ? "0" + (datetime.getMonth() + 1) : datetime.getMonth() + 1;
    var date = datetime.getDate() < 10 ? "0" + datetime.getDate() : datetime.getDate();
    var hour = datetime.getHours() < 10 ? "0" + (datetime.getHours()) : (datetime.getHours());
    var minute = datetime.getMinutes() < 10 ? "0" + datetime.getMinutes() : datetime.getMinutes();
    var second = datetime.getSeconds() < 10 ? "0" + datetime.getSeconds() : datetime.getSeconds();
    return year + "-" + month + "-" + date + " " + hour + ":" + minute + ":" + second;
}

function getNowDateTime2() {
    var datetime = new Date();
    var year = datetime.getFullYear();
    var month = datetime.getMonth() + 1 < 10 ? "0" + (datetime.getMonth() + 1) : datetime.getMonth() + 1;
    var date = datetime.getDate() < 10 ? "0" + datetime.getDate() : datetime.getDate();
    var hour = datetime.getHours() < 10 ? "0" + (datetime.getHours()) : (datetime.getHours());
    var minute = datetime.getMinutes() < 10 ? "0" + datetime.getMinutes() : datetime.getMinutes();
    var second = datetime.getSeconds() < 10 ? "0" + datetime.getSeconds() : datetime.getSeconds();
    var millsecond = datetime.getMilliseconds() < 10 ? "0" + datetime.getMilliseconds() : datetime.getMilliseconds();
    return year + "-" + month + "-" + date + " " + hour + ":" + minute + ":" + second + ":" + millsecond;
}

/**
 * 格式化时间为yyyy-MM-dd HH-mm-ss的形式
 */
function formatedate(time) {
    if (time == undefined || time == null || time == "") {
        return "";
    }
    if (time.indexOf('.') != -1) {
        time = time.substring(0, time.indexOf('.'));
    }
    time = time.replace('T', ' ');
    time = time.replace(/-/g, '/');
    //IOS时间类型的不支持"-"，需要转换为"/"
    var datetime = new Date(time);
    var year = datetime.getFullYear();
    var month = datetime.getMonth() + 1 < 10 ? "0" + (datetime.getMonth() + 1) : datetime.getMonth() + 1;
    var date = datetime.getDate() < 10 ? "0" + datetime.getDate() : datetime.getDate();
    var hour = datetime.getHours() < 10 ? "0" + (datetime.getHours()) : (datetime.getHours());
    var minute = datetime.getMinutes() < 10 ? "0" + datetime.getMinutes() : datetime.getMinutes();
    var second = datetime.getSeconds() < 10 ? "0" + datetime.getSeconds() : datetime.getSeconds();
    return year + "/" + month + "/" + date + " " + hour + ":" + minute + ":" + second;
}

//获取当前日期并格式化
function getNowFormatDate() {
    var date = new Date();
    var seperator1 = "-";
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    var strDate = date.getDate();
    if (month >= 1 && month <= 9) {
        month = "0" + month;
    }
    if (strDate >= 0 && strDate <= 9) {
        strDate = "0" + strDate;
    }
    var currentdate = year + seperator1 + month + seperator1 + strDate;
    return currentdate;
}

//获取到当前的时间差
function getTimeDifference(lasttime) {
    var date1= lasttime.replace("T"," ");  //开始时间
    date1 = date1.replace(/-/g, '/');
    date1 = date1.substring(0,19);
    var date2 = new Date();    //结束时间
    var date3 = date2.getTime() - (new Date(date1.toString())).getTime();   //时间差的毫秒数      
    //------------------------------
    var days=Math.floor(date3/(24*3600*1000));//计算出相差天数
    var leave1=date3%(24*3600*1000);    //计算天数后剩余的毫秒数
    var hours=Math.floor(leave1/(3600*1000));//计算出小时数
    var leave2=leave1%(3600*1000);        //计算小时数后剩余的毫秒数
    var minutes=Math.floor(leave2/(60*1000));//计算相差分钟数
    var leave3=leave2%(60*1000);      //计算分钟数后剩余的毫秒数
    var seconds=Math.round(leave3/1000);//计算相差秒数
    
    if(days > 0){
        return days+"天前";
    }
    if(hours > 0){
        return hours+"小时前";
    }
    if(minutes > 0){
        return minutes+"分钟前";
    }
    if(seconds > 0){
        return seconds+"秒前";
    }
}

/**
 * 格式化时间为yyyy-MM-dd的形式
 */
function formatedate2(time) {
    if (time) {
        time = time.replace("&nbsp;", "");
        if (time == undefined || time == null || time == "") {
            return "";
        }
        if (time.indexOf('.') != -1) {
            time = time.substring(0, time.indexOf('.'));
        }
        time = time.replace('T', ' ');
        time = time.replace(/-/g, '/');
        var datetime = new Date(time);
        var year = datetime.getFullYear();
        var month = datetime.getMonth() + 1 < 10 ? "0" + (datetime.getMonth() + 1) : datetime.getMonth() + 1;
        var date = datetime.getDate() < 10 ? "0" + datetime.getDate() : datetime.getDate();
        return year + "-" + month + "-" + date;
    }
}

// 格式化时间为yyyy年mm月dd日 12:00:00
function formatedate3(time) {
    if (time == undefined || time == null || time == "") {
        return "";
    }
    if (time.indexOf('.') != -1) {
        time = time.substring(0, time.indexOf('.'));
    }
    time = time.replace('T', ' ');
    time = time.replace(/-/g, '/');
    //IOS时间类型的不支持"-"，需要转换为"/"
    var datetime = new Date(time);
    var year = datetime.getFullYear();
    var month = datetime.getMonth() + 1 < 10 ? "0" + (datetime.getMonth() + 1) : datetime.getMonth() + 1;
    var date = datetime.getDate() < 10 ? "0" + datetime.getDate() : datetime.getDate();
    var hour = datetime.getHours() < 10 ? "0" + (datetime.getHours()) : (datetime.getHours());
    var minute = datetime.getMinutes() < 10 ? "0" + datetime.getMinutes() : datetime.getMinutes();
    var second = datetime.getSeconds() < 10 ? "0" + datetime.getSeconds() : datetime.getSeconds();
    return year + "年" + month + "月" + date + "日      " + hour + ":" + minute + ":" + second;
}

/* 格式化数量四舍五入保留三位小数（输入1.1256 输出1.126）*/
function formateNum(num) {
    if (isNaN(num)) {
        return "0.000";
    } else if ((num + "").indexOf('.') < 0) {
        return num + ".000";
    }
    var numarry = (num + "").split('.');
    if (numarry[1].length < 4) {
        var zero = "";
        for (var i = 1; i < 4 - numarry[1].length; i++) {
            zero += "0";
        }
        return num + zero;
    }
    var aNew;
    var re = /([0-9]+\.[0-9]{4})[0-9]*/;
    aNew = num + "".replace(re, "$1");
    var num1 = aNew.substring(0, aNew.length - 2);
    var num2 = aNew.substring(aNew.length - 2, aNew.length - 1);
    if (aNew.substring(aNew.length - 1, aNew.length) > 4) {
        num2++;
    }
    return num1 + "" + num2;
}

/*这个方法是格式化成  (输入1输出1.000 )*/
function FormatNumber(s, n) {
    ///<summary>格式化数字</summary>
    /// <param name="s" type="Number">要格式化的数字</param>
    /// <param name="n" type="Number">小数位数，默认为 2 位</param>
    n = typeof (n) == "undefined" ? 2 : n;
    n = n > 0 && n <= 20 ? n : 2;
    s = parseFloat((s + "").replace(/[^\d\.-]/g, ""));
    if (isNaN(s)) {
        s = 0;
    }
    var isMinus = s < 0;
    var multi = Math.pow(10, n);
    s = Math.round(s * multi) / multi;
    s = Math.abs(s).toFixed(n) + "";
    var l = s.split(".")[0].split("").reverse(),
        r = s.split(".")[1];
    t = "";
    for ( i = 0; i < l.length; i++) {
        t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
    }
    return ( isMinus ? "-" : "") + t.split("").reverse().join("") + "." + r;
}

/*这个方法是格式化成  (输入1输出1.000 )*/
function FormatNumberInt(num) {
    if(!num){
        return '0';
    }
    if(isNaN(num)){
        num = num.replace(/,/g,"");
    }
    num = Math.round(num);
    num = Math.abs(num);
    num = "" + num;
    for (var i = 0; i < Math.floor((num.length - (1 + i)) / 3); i++){
        num = num.substring(0, num.length - (4 * i + 3)) + ',' + num.substring(num.length - (4 * i + 3));
    }
    return num;
}

/*
 格式化金额，保留两位小数（四舍五入）例如输入10000.125 输出10,000.13
 */
function formatMoney(num) {
    if (isNaN(num)) {
        return "0.00";
    }
    num = num.toString().replace(/\$|\,/g, '');
    if (isNaN(num))
        num = "0";
    sign = (num == ( num = Math.abs(num)));
    num = Math.floor(num * 100 + 0.50000000001);
    cents = num % 100;
    num = Math.floor(num / 100).toString();
    if (cents < 10)
        cents = "0" + cents;
    for (var i = 0; i < Math.floor((num.length - (1 + i)) / 3); i++)
        num = num.substring(0, num.length - (4 * i + 3)) + ',' + num.substring(num.length - (4 * i + 3));
    return (((sign) ? '' : '-') + num + '.' + cents);
}

/*
 格式化金额，保留两位小数（四舍五入）例如输入10000.1255 输出10,000.123
 */
function formatMoney3(s, n) {
    n = n > 0 && n <= 20 ? n : 2;
    s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
    var l = s.split(".")[0].split("").reverse(),
        r = s.split(".")[1];
    t = "";
    for ( i = 0; i < l.length; i++) {
        t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
    }
    return t.split("").reverse().join("") + "." + r;
}

/*
 格式化金额，除以10000后，保留两位小数（四舍五入）例如输入10000.125 输出1.00
 */
function formatMoney2(num) {
    if (isNaN(num)) {
        return "0.00";
    }
    num = num.toString().replace(/\$|\,/g, '');
    if (isNaN(num))
        num = "0";
    sign = (num == ( num = Math.abs(num)));
    num = num / 10000;
    num = Math.floor(num * 100 + 0.50000000001);
    cents = num % 100;
    num = Math.floor(num / 100).toString();
    if (cents < 10)
        cents = "0" + cents;
    for (var i = 0; i < Math.floor((num.length - (1 + i)) / 3); i++)
        num = num.substring(0, num.length - (4 * i + 3)) + ',' + num.substring(num.length - (4 * i + 3));
    return (((sign) ? '' : '-') + num + '.' + cents);
}

//主题信息的展开折叠
function ToggleInfo(id, init_infoHeight) {
    var info = document.getElementById(id);
    if (info) {
        init_infoHeight = $("#" + id).height();
        $("#" + id).bind("click", function() {
            event.preventDefault();
            toggleAutoHeight(info, init_infoHeight, 500, 'ease-in');
        });
    }
}

/*获取当前系统时间2016-09-09格式*/
function getNowDate() {
    var myDate = new Date();
    var monthval = (myDate.getMonth() + 1);
    monthval = monthval < 10 ? "0" + monthval : monthval;
    var dayval = myDate.getDate();
    dayval = dayval < 10 ? "0" + dayval : dayval;
    var nowdate = myDate.getFullYear() + '-' + monthval + '-' + dayval;
    return nowdate;
}

/**
 *计算2个日期相差多少天
 *@param String strDateStart和strDateEnd 日期，格式为2014-04-04
 */
function getDays(strDateStart, strDateEnd) {
    var strSeparator = "-";
    //日期分隔符
    var oDate1;
    var oDate2;
    oDate1 = strDateStart.split(strSeparator);
    oDate2 = strDateEnd.split(strSeparator);
    var strDateS = new Date(oDate1[0] + "/" + oDate1[1] + "/" + oDate1[2]);
    var strDateE = new Date(oDate2[0] + "/" + oDate2[1] + "/" + oDate2[2]);
    var iDays = parseInt(Math.abs(strDateS - strDateE) / 1000 / 60 / 60 / 24)//把相差的毫秒数转换为天数
    return iDays;
}

/**
 * 将小于10的数字格式化为01、02的形式
 */
function setNum(s) {
    return (parseInt(s) > 9) ? s : '0' + s;
}

/**
 * 删除文本左右两端的空格
 */
function trim(str) {
    return str.replace(/(^\s*)|(\s*$)/g, "");
}

/**
 * 删除文本左边的空格
 */
function ltrim(str) {
    return str.replace(/(^\s*)/g, "");
}

/**
 * 删除文本右边的空格
 */
function rtrim(str) {
    return str.replace(/(\s*$)/g, "");
}

/**
 * 计算字符串的长度
 */
function fucCheckLength(strTemp) {
    var i,
        sum;
    sum = 0;
    for ( i = 0; i < strTemp.length; i++) {
        if ((strTemp.charCodeAt(i) >= 0) && (strTemp.charCodeAt(i) <= 255))
            sum = sum + 1;
        else
            sum = sum + 2;
    }
    return sum;
}

/**
 * 取input数据
 * @id: input标签id
 * 返回值：数据内容
 */
function getValue(id) {
    var e = $$(id);
    if (e)
        return trim(e.value);
}

/**
 * 设置input数据
 * @id: input标签id
 * @val: 要设置的数据
 */
function setValue(id, val) {
    var e = $$(id);
    if (e)
        e.value = val;
}

/**
 *  获取某个对象或值是否等于undefined或空
 */
function isDefine(para) {
    if ( typeof para == 'undefined' || para == "" || para == null || para == undefined)
        return false;
    else
        return true;
}

/**
 * json对象转为string
 * @param {Object} j
 */
function jsonToStr(j) {
    return JSON.stringify(j);
}

/**
 * string转为json对象
 * @param String s
 */
function strToJson(s) {
    if (s == "") {
        return {};
    }
    return JSON.parse(s);
}

/**
 * 根据Y和N返回是和否
 */
function getYesOrNo(flag) {
    var name = "否";
    if (flag == "Y") {
        name = "是";
    }
    return name;
}

function FormateValue(FormateStr, value) {
    var NewValue;
    if (value == "" || typeof (value) == 'object' || value == "无") {
        return value;
    }
    switch(FormateStr) {
    case "Money":
        NewValue = formatMoney(value);
        break;
    case "WMoney":
        NewValue = formatMoney2(value);
        break;
    case "IntMoney":
        NewValue = tran(ConvertInt(value) + "");
        break;
    case "Date":
        NewValue = formatedate2(value);
        break;
    case "Num":
        NewValue = formateNum(value);
        break;
    case "IntNum":
        NewValue = tran(ConvertInt(value) + "");
        break;
    default:
        break;
    }
    return NewValue;
}

//将数值用，隔开。显示为千分位的形式 例如100000.02 输出100,000.02
function tran(value) {
    var v,
        j,
        sj,
        rv = "";
    v = value.replace(/,/g, "").split(".");
    j = v[0].length % 3;
    sj = v[0].substr(j).toString();
    for (var i = 0; i < sj.length; i++) {
        rv = (i % 3 == 0) ? rv + "," + sj.substr(i, 1) : rv + sj.substr(i, 1);
    }
    var rvalue = (v[1] == undefined) ? v[0].substr(0, j) + rv : v[0].substr(0, j) + rv + "." + v[1];
    if (rvalue.charCodeAt(0) == 44) {
        rvalue = rvalue.substr(1);
    }
    return rvalue;
}

//获取html标记内容
function getHtmlContent(name) {
    var ahtml = $(document.body).html();
    var rhtml = "";
    var sindex = ahtml.indexOf('<!--' + name + '--');
    var eindex = ahtml.indexOf('--' + name + '-->');
    if (sindex >= 0 && eindex >= 0) {
        rhtml = ahtml.substring(sindex + (name.length + 6), eindex);
    }
    return rhtml;
}

//四舍五入,将数值转成整数 例如100.52 输出101
function ConvertInt(value) {
    if (value == undefined || value == "") {
        return 0;
    } else {
        return Math.round(value);
    }
}

/*处理商品明细中扩展属性的格式化问题*/
function GetDealJson(json, array) {
    var Newarray = [];
    if (json.length) {
        $.each(json, function() {
            DealJson(this, array);
            Newarray.push(this);
        });
    } else {
        DealJson(json, array);
        Newarray.push(json);
    }
    return Newarray;
}

function DealJson(obj, array) {
    var item = obj.ExItems.BillDetailExItem;
    $.each(array, function() {
        var GXObj = this;
        var key = this.Key;
        if (item.length) {
            $.each(item, function() {
                if (this.ParmQLF == key) {
                    var value = this.ParmValue;
                    var type = this.ParmType;
                    if (type == "NUM" && typeof (value) == 'object') {
                        value = "0";
                    }
                    if (GXObj.Formate) {
                        value = FormateValue(GXObj.Formate, value);
                    }
                    if (key == "CurrencyCode") {
                        key = "ReCurrencyCode";
                    }
                    obj[key] = value;
                    return;
                }
            });
        } else {
            if (item.ParmQLF == key) {
                var value = item.ParmValue;
                if (GXObj.Formate) {
                    value = FormateValue(GXObj.Formate, value);
                }
                if (key == "CurrencyCode") {
                    key = "ReCurrencyCode";
                }
                obj[key] = value;
                return;
            }
        }
    });
    obj = GetDealObj(obj);
}

/* 处理对象中属性值为object是将值置空*/
function GetDealObj(obj) {
    var newobj = obj;
    $.each(obj, function(key, val) {
        var value = val;
        if ( typeof (value) == 'object') {
            value = "&nbsp;";
        } else if (value == "") {
            value = "&nbsp;";
        }
        newobj[key] = value;
    });
    return newobj;
}

/* 处理对象中属性值为object是将值置空*/
function GetDealObj2(arr, formatarr) {
    var newarr = new Array();
    $.each(arr, function() {
        var newobj = new Array();
        $.each(this, function(key, val) {
            var value = val.ParmValue;
            if ( typeof (value) == 'object') {
                value = "&nbsp;";
            } else if (value == "") {
                value = "&nbsp;";
            }
            newobj[val.ParmQLF] = value;
        });
        $.each(formatarr, function() {
            var obj = this;
            var key = this.Key;
            var value = newobj[this.Key];
            if (obj.Formate) {
                newobj[this.Key] = FormateValue(obj.Formate, value);
            }
        });
        newarr.push(newobj);
    });
    return newarr;
}

/*处理商品明细中属性的格式化问题，第一个参数表示数据[必须为数组]，第二个参数是需格式化字段的数组*/
function GetDealJson2(json, array) {
    var Newarray = [];
    if (json) {
        if (json.length) {
            $.each(json, function() {
                var newobj = this;
                DealJson2(this, newobj, array);
                Newarray.push(newobj);
            });
        } else {
            var newobj = json;
            DealJson2(json, newobj, array);
            Newarray.push(newobj);
        }
    }
    return Newarray;
}

function DealJson2(Obj, newobj, array) {
    if (array.length > 0) {
        $.each(array, function() {
            var SXObj = this;
            $.each(Obj, function(key, value) {
                if (key == SXObj.Key) {
                    if (SXObj.Formate) {
                        value = FormateValue(SXObj.Formate, value);
                    }
                }
                if ( typeof (value) == 'object') {
                    value = "&nbsp;";
                }
                newobj[key] = value;
            });
        });
    } else {
        $.each(Obj, function(key, value) {
            if ( typeof (value) == 'object') {
                value = "&nbsp;";
            }
            newobj[key] = value;
        });
    }
}

/**
 *将指定元素的值赋值给对应字段
 */
function appendFieldValue(field, array) {
    var value = $("#" + field).html();
    $.each(array, function() {
        $("#" + this).html(value);
    });
}

/**
 *将指定值赋值给对应字段
 */
function appendFieldValue2(value, array) {
    $.each(array, function() {
        $("#" + this).html(value);
    });
}

/**
 *将指定元素赋值给对应字段
 */
function getParmValue(list, field) {
    var result;
    $.each(list, function() {
        var key = this.ParmQLF;
        var value = this.ParmValue;
        if ( typeof (value) != 'object' && field == key) {
            result = value;
        }
    });
    return result;
}

/*处理单据主体信息的格式化问题*/
function DealHeader(list, array) {
    $.each(list, function() {
        var key = this.ParmQLF;
        var value = this.ParmValue;
        if ( typeof (value) != 'object') {
            $("#" + key).html(value);
        } else if (value == "") {
            $("#" + key).html("&nbsp;");
        } else {
            $("#" + key).html("&nbsp;");
        }
    });
    $.each(array, function() {
        var obj = this;
        var key = this.Key;
        var value = $("#" + key).html();
        if (obj.Formate) {
            value = FormateValue(obj.Formate, value);
            if ( typeof (value) != 'object') {
                $("#" + key).html(value);
                if (value == "") {
                    $("#" + key).html("&nbsp;");
                }
            }
        }
    });
}

///////////////////////

/**
 * 调用本地浏览器打开网址
 * @param String url
 */
function loadLink(url) {
    var appInfo = '';
    var filter = '';
    var dataInfo = url.toLowerCase();
    var pf = uexWidgetOne.platformName;
    if (pf == 'android') {
        appInfo = 'android.intent.action.VIEW';
        filter = 'text/html';
    }
    if (dataInfo.indexOf('http://') < 0 && dataInfo.indexOf('https://') < 0) {
        dataInfo = 'http://' + dataInfo;
    }
    uexWidget.loadApp(appInfo, filter, dataInfo);
}

/**
 * 下载文件
 *@String url_update 下载路径
 *@String name   保存的文件名及格式 例：file.jpg
 *@funciton cb   下载成功后的回调函数
 **/
var did = 1000;
function downFile(url_update, name, cb) {
    did++;
    if (isAndroid)
        var saveUpdate = "/sdcard/download/" + name;
    else
        var saveUpdate = "wgt://data/" + name;
    $toast("正在加载中...");
    uexDownloaderMgr.onStatus = function(opCode, fileSize, percent, status) {
        switch(status) {
        case 0:
            logs(opCode + "==" + percent);
            var str = '下载进度：' + percent + '%';
            if (fileSize == -1)
                str = '下载中，请稍候...';
            uexWindow.toast('1', '5', str, '');
            break;
        case 1:
            uexDownloaderMgr.closeDownloader(opCode);
            uexWindow.closeToast();
            cb(saveUpdate);
            break;
        case 2:
            uexDownloaderMgr.closeDownloader(opCode);
            break;
            ;
        }
    }
    uexDownloaderMgr.cbCreateDownloader = function(opCode, dataType, data) {
        if (data == 0) {
            uexDownloaderMgr.download(opCode, url_update, saveUpdate, '0');
        } else {
            alert("创建失败");
        }
    }

    uexFileMgr.cbIsFileExistByPath = function(opId, dataType, data) {
        if (isDefine(data)) {
            cb(saveUpdate);
        } else {
            did++;
            uexDownloaderMgr.createDownloader(did);
        }
    }
    uexFileMgr.isFileExistByPath(did, saveUpdate);
}

/**
 *检查网络
 *返回值：-1=网络不可用  0=WIFI网络  1=3G网络  2=2G网络
 */
function checkNet(cb) {
    uexDevice.cbGetInfo = function(opCode, dataType, data) {
        var device = eval('(' + data + ')');
        var connectStatus = device.connectStatus;
        if (connectStatus == -1)
            connectStatus = 0;
        if (isDefine(connectStatus)) {
            cb(connectStatus);
            //if(connectStatus==-1){
            //  console.log('网络状态：网络不可用');
            //}else if(connectStatus==0){
            //  console.log('网络状态：WIFI网络');
            //}else if(connectStatus==1){
            //  console.log('网络状态：3G网络');
            //}else if(connectStatus==2){
            //  console.log('网络状态：2G网络');
            //}
        }
    }
    uexDevice.getInfo('13');
}

/*
 *判断IOS版本号是否大于7，大于7在顶部加20
 *为了避免在每个页面都调用这个方法，可以在zy_control.js文件的zy_init()方法中调用。在使用这种方法时，在应用的首页就不要使用zy_init方法了。
 *而是改为直接调用该方法，并且传入一个回调函数，在回调函数中在打开浮动窗口，否则就会出现打开的浮动窗口位置错误的问题
 */
function add20ToHeader(cb) {
    //if(cb) cb();
    //return;
    if (isAndroid) {
        if (cb)
            cb();
        return;
    }

    if (getLocVal('IOS7Plus')) {
        try {
            if (getLocVal('IOS7Plus') == 2) {
                if ($$('header').style.paddingTop) {
                    $$('header').style.paddingTop = (parseInt($$('header').style.paddingTop) + 20) + 'px';
                } else {
                    $$('header').style.paddingTop = '20px';
                }
            }
        } catch (e) {
        }
        if (cb)
            cb();
    } else {
        uexDevice.cbGetInfo = function(opId, dataType, data) {
            if (data) {
                var device = JSON.parse(data);
                var os = parseInt(device.os);
                //              alert("os="+os);
                if (os >= 7) {
                    setLocVal('IOS7Plus', 2);
                    try {
                        if ($$('header').style.paddingTop) {
                            $$('header').style.paddingTop = (parseInt($$('header').style.paddingTop) + 20) + 'px';
                        } else {
                            $$('header').style.paddingTop = '20px';
                        }
                    } catch (e) {
                    }
                } else {
                    setLocVal('IOS7Plus', 1);
                }
            }
            if (cb)
                cb();
        };
        uexDevice.getInfo('1');
    }
}

//////////文件操作/////////////
var fileOpId = parseInt(Math.random() * 10000);
var filePath = 'wgt://data/locFile.txt';
/**
 * 删除文件
 */
function deletFileByPath(cb) {
    uexFileMgr.cbDeleteFileByPath = function(fileOpId, dataType, data) {
        var str = '删除失败';
        if (dataType == 2 && data == 0)
            str = '删除成功';
        if (cb)
            cb(str);
    }

    uexFileMgr.deleteFileByPath(filePath);
    uexFileMgr.closeFile(fileOpId);
    fileOpId++;
}

/**
 * 写文件
 */

function writeFile(val) {
    uexFileMgr.cbIsFileExistByPath = function(opId, dataType, data) {
        if (dataType == 2) {
            if (data == 0) {//'文件不存在';
                uexFileMgr.cbCreateFile = function(opId, dataType, data) {
                    if (dataType == 2 && data == 0) {
                        writeIn(val);
                    };
                }
                uexFileMgr.createFile(fileOpId, filePath);
                uexFileMgr.closeFile(fileOpId);
                fileOpId++;
            } else if (data == 1) {//'文件存在';
                writeIn(val);
            }

        }
    }
    uexFileMgr.isFileExistByPath(filePath);
    uexFileMgr.closeFile(fileOpId);
    fileOpId++;
}

function writeIn(val) {
    var content = val;
    var inMode = 0;
    //0为直接写内容，会把之前的内容覆盖；1为追加到文件里
    uexFileMgr.openFile(fileOpId, filePath, 1);
    uexFileMgr.writeFile(fileOpId, inMode, content);
    uexFileMgr.closeFile(fileOpId);
    opId++;
}

/**
 * 读文件
 */
function readFile(cb) {
    uexFileMgr.cbReadFile = function(fileOpId, dataType, data) {
        if (dataType == 0) {
            if (cb) {
                cb(data);
            }
        }
    }
    var inLen = -1;
    //-1表示全部读取
    uexFileMgr.openFile(fileOpId, filePath, 1);
    uexFileMgr.readFile(fileOpId, inLen);
    uexFileMgr.closeFile(fileOpId);
    fileOpId++;
}

//加码
function Encrypt(str, pwd) {
    if (str == "")
        return "";
    str = escape(str);
    if (!pwd || pwd == "") {
        var pwd = "@sinochemmobile1234";
    }
    pwd = escape(pwd);
    if (pwd == null || pwd.length <= 0) {
        alert("Please enter a password with which to encrypt the message.");
        return null;
    }
    var prand = "";
    for (var I = 0; I < pwd.length; I++) {
        prand += pwd.charCodeAt(I).toString();
    }
    var sPos = Math.floor(prand.length / 5);
    var mult = parseInt(prand.charAt(sPos) + prand.charAt(sPos * 2) + prand.charAt(sPos * 3) + prand.charAt(sPos * 4) + prand.charAt(sPos * 5));

    var incr = Math.ceil(pwd.length / 2);
    var modu = Math.pow(2, 31) - 1;
    if (mult < 2) {
        alert("Algorithm cannot find a suitable hash. Please choose a different password. \nPossible considerations are to choose a more complex or longer password.");
        return null;
    }
    var salt = Math.round(Math.random() * 1000000000) % 100000000;
    prand += salt;
    while (prand.length > 10) {
        prand = (parseInt(prand.substring(0, 10)) + parseInt(prand.substring(10, prand.length))).toString();
    }
    prand = (mult * prand + incr) % modu;
    var enc_chr = "";
    var enc_str = "";
    for (var I = 0; I < str.length; I++) {
        enc_chr = parseInt(str.charCodeAt(I) ^ Math.floor((prand / modu) * 255));
        if (enc_chr < 16) {
            enc_str += "0" + enc_chr.toString(16);
        } else
            enc_str += enc_chr.toString(16);
        prand = (mult * prand + incr) % modu;
    }
    salt = salt.toString(16);
    while (salt.length < 8)
    salt = "0" + salt;
    enc_str += salt;
    return enc_str;
}

//解码
function Decrypt(str, pwd) {
    if (str == "")
        return "";
    if (!pwd || pwd == "") {
        var pwd = "@sinochemmobile1234";
    }
    pwd = escape(pwd);
    if (str == null || str.length < 8) {
        alert("A salt value could not be extracted from the encrypted message because it's length is too short. The message cannot be decrypted.");
        return;
    }
    if (pwd == null || pwd.length <= 0) {
        alert("Please enter a password with which to decrypt the message.");
        return;
    }
    var prand = "";
    for (var I = 0; I < pwd.length; I++) {
        prand += pwd.charCodeAt(I).toString();
    }
    var sPos = Math.floor(prand.length / 5);
    var mult = parseInt(prand.charAt(sPos) + prand.charAt(sPos * 2) + prand.charAt(sPos * 3) + prand.charAt(sPos * 4) + prand.charAt(sPos * 5));
    var incr = Math.round(pwd.length / 2);
    var modu = Math.pow(2, 31) - 1;
    var salt = parseInt(str.substring(str.length - 8, str.length), 16);
    str = str.substring(0, str.length - 8);
    prand += salt;
    while (prand.length > 10) {
        prand = (parseInt(prand.substring(0, 10)) + parseInt(prand.substring(10, prand.length))).toString();
    }
    prand = (mult * prand + incr) % modu;
    var enc_chr = "";
    var enc_str = "";
    for (var I = 0; I < str.length; I += 2) {
        enc_chr = parseInt(parseInt(str.substring(I, I + 2), 16) ^ Math.floor((prand / modu) * 255));
        enc_str += String.fromCharCode(enc_chr);
        prand = (mult * prand + incr) % modu;
    }
    return unescape(enc_str);
}

//改变字体大小
function ChangeFontStyle(fontsize, styleName) {

    //stylename 可以填写 .classname,#id,body
    addCssByStyle(styleName + " {font-size: " + fontsize + " !important;");

    function addCssByStyle(cssString, fontsize) {
        var doc = document;
        var style = doc.createElement("style");
        style.setAttribute("type", "text/css");
        if (style.styleSheet) {// IE
            style.styleSheet.cssText = cssString;
        } else {// w3c
            var cssText = doc.createTextNode(cssString);
            style.appendChild(cssText);
            style.id = fontsize;
        }

        var heads = doc.getElementsByTagName("head");
        if (heads.length)
            heads[0].appendChild(style);
        else
            doc.documentElement.appendChild(style);
    }

}

function getRandom(n) {
    return Math.floor(Math.random() * n + 1)
}

//把当前记录的msgId缓存的本地
function storageReadedMsg(msgId) {
    var localStr = getLocVal("readedMsgs");
    if (localStr == "") {
        var arr = [];
        arr[0] = msgId;
        setLocVal("readedMsgs", jsonToStr(arr));
        return;
    }
    var temp = strToJson(localStr);
    if ( temp instanceof Array) {
        if (temp.indexOf(msgId) == -1) {
            temp.push(msgId);
            setLocVal("readedMsgs", jsonToStr(temp));
        }
        return;
    }
}

//点击完new标识的记录时，隐藏new标识
function cancelNewIcon(msgId) {
    var curnew = $("#" + msgId);
    if (!Zepto.isEmptyObject(curnew)) {
        curnew.find('div[isnew=Y]').hide();
    }
}

//POST提交数据格式
function format(requestInfo) {
    //requestInfo=JSON.parse(requestInfo);
    var items = requestInfo.workflowMainTableInfo[0].requestRecords[0].WorkflowRequestTableRecord[0].workflowRequestTableFields[0].WorkflowRequestTableField;

    var tmps = [];
    for (var i = 0; i < items.length; i++) {
        //if (items[i].edit[0]) {
        tmps.push({
            edit : items[i].edit,
            view : items[i].view,
            fieldId : items[i].fieldId,
            fieldName : items[i].fieldName,
            fieldType : items[i].fieldType,
            fieldValue : items[i].fieldValue,
            fieldOrder : items[i].fieldOrder,
            fieldShowName : items[i].fieldShowName
        });
        //}
    }

    var workflowBaseInfo = requestInfo.workflowBaseInfo[0];
    requestInfo.workflowMainTableInfo[0].requestRecords[0].WorkflowRequestTableRecord[0].workflowRequestTableFields[0].WorkflowRequestTableField = tmps;
    requestInfo.workflowBaseInfo = workflowBaseInfo;
    delete requestInfo.workflowRequestLogs;
    delete requestInfo.workflowDetailTableInfos;
    delete requestInfo.workflowPhrases;
    delete requestInfo.workflowHtmlShow;
    delete requestInfo.workflowHtmlTemplete;
    return requestInfo;
}

/*
 * ios7头部状态栏修改ios7

 */
function ios7Head() {
    var a = uexWidgetOne.iOS7Style,
        b = uexWidgetOne.isFullScreen;
    if ("1" == a && "1" != b) {
        var bodys = window.document.getElementById("body");
        bodys.className = bodys.className + " uh_ios7";
        //alert(bodys.className);
    }
}

var focusInputId = "";
/*选择日期*/
function openInputDatePicker(input) {
    var cJson = 1;
    uexControl.cbOpenDatePicker = function(opCode, dataType, data) {
        switch(dataType) {
        case cJson:
            var obj = eval('(' + data + ')');
            var month = obj.month + "";
            var day = obj.day + "";
            if (month.length == 1) {
                month = "0" + month;
            }
            if (day.length == 1) {
                day = "0" + day;
            }
            $(focusInputId).val(obj.year + "-" + month + "-" + day);
            $(focusInputId).change();
            break;
        }
    };
    focusInputId = "#" + input.id;
    if ($(focusInputId).val() == "") {
        var myDate = new Date();
        myDate.toLocaleDateString();
    } else {
        var myDate = new Date($(focusInputId).val());
        myDate.toLocaleDateString();
    }
    //可以获取当前日期

    uexControl.openDatePicker(myDate.getFullYear(), myDate.getMonth() + 1, myDate.getDate());
    input.blur();
}

/*选择时间*/
function openInputTimePicker(input) {
    var cJson = 1;
    uexControl.cbOpenTimePicker = function(opCode, dataType, data) {
        switch(dataType) {
        case cJson:
            var obj = eval('(' + data + ')');
            var hour = obj.hour + "";
            var minute = obj.minute + "";
            if (hour.length == 1) {
                hour = "0" + hour;
            }
            if (minute.length == 1) {
                minute = "0" + minute;
            }
            $(focusInputId).val(hour + ":" + minute);
            $(focusInputId).change();
            break;
        }
    };

    focusInputId = "#" + input.id;
    var myDate = new Date();
    var hours = "";
    var times = "";
    if ($(focusInputId).val() == "") {
        hours = myDate.getHours();
        times = myDate.getMinutes();
    } else {
        hours = $(focusInputId).val().split(':')[0];
        times = parseInt($(focusInputId).val().split(':')[1]).toString();
    }
    //var myDate = new Date();
    //可以获取当前时间
    //myDate.toLocaleTimeString();
    uexControl.openTimePicker(hours, times);
    input.blur();
}

function SetPageY(btnarry, callfun) {
    delloading();
    for (var i in btnarry) {
        var id = btnarry[i].id;
        var classname = btnarry[i].classname;
        $("#" + id).removeClass("btnEnable");
        $("#" + id).addClass(classname);
    }
    if (callfun) {
        callfun();
    }
}

function SetPageN(btnarry) {
    addmotai();
    for (var i in btnarry) {
        var id = btnarry[i].id;
        var classname = btnarry[i].classname;
        $("#" + id).removeClass(classname);
        $("#" + id).addClass("btnEnable");
        $("#" + id).unbind("click");
    }
}

function backToTop() {
    // var btn = $("<div class='backToTop uc-a1 MainBlueFont' onclick='$(window).scrollTop(0)'>返回顶部</div>");
    // $("body").append(btn);
    // btn.css("left", $(window).width() - btn.width() + "px");
    // btn.css("top", $(window).height() - btn.height() + $(window).scrollTop() - 6 + "px");

    $(window).scrollTop(0);
}

/**
 *
 * 获取网络连接失败或没有数据时的提示html
 *
 * FunCallBack:点击html块的回调函数
 * msg：提示语[默认为网络不给力，请点击重试!]
 *
 */

function GetAjaxRequestFaillHtml(FunCallBack, msg, NoDataImgClass) {
    var CallBack = "";
    var failhtml = "";
    var NoDataImg = "NoDataImg";
    if (NoDataImgClass) {
        NoDataImg = NoDataImgClass;
    }
    if (FunCallBack != "") {
        CallBack = "'RemoveDivs(this);" + FunCallBack + "'";
        failhtml += "<div class='ub ub-ac ub-pc ub-ver Nodata' onclick=" + CallBack + ">";
        failhtml += '<div class="ub ub-ac ub-pc " style="padding-top:1rem">';
        failhtml += '  <div class="NoLineImg ub-img5 grid_icon">';
        failhtml += ' </div>';
        failhtml += '</div>';
        failhtml += '<div id="msgDiv" class="ub ub-ac ub-pc" style="font-size:.26rem;margin-top:.5rem;color: #999999;padding-bottom:1rem;">';
        if (msg) {
            failhtml += msg;
        } else {
            failhtml += "网络不给力，请点击重试!";
        }
        failhtml += ' </div>';
        failhtml += '</div>';
    } else {
        failhtml += '<div class="ub ub-ac ub-pc Nodata" style="padding-top:1rem">';
        failhtml += '  <div class="' + NoDataImg + ' ub-img5 grid_icon">';
        failhtml += ' </div>';
        failhtml += '</div>';
        failhtml += '<div id="msgDiv" class="ub ub-ac ub-pc" style="font-size:.26rem;margin-top:.5rem;color: #999999;padding-bottom:1rem;">';
        failhtml += msg;
        failhtml += ' </div>';
    }
    return failhtml;
}

function RemoveDivs(obj) {
    $(obj).remove();
}

/**
 *在加载下一页之前需要调用的方法 [由于最后一页提示方式的改变，该方法现在为空]
 */
function beforeGetNextData() {
    //if ($(".Nodata").length > 0) {
    //$(".Nodata").remove();
    //}
}

/**
 *列表没有数据的后续处理动作
 * obj：列表容器的DOM对象
 * isInit：是否为列表数据首次加载[该参数现在无效，可传任意值]
 * pageIndex：页码
 * title：数据为空时的提示语
 */
function listNoData(obj, isInit, pageIndex, title) {
    if (pageIndex <= 1) {
        if (title) {
            obj.html(GetAjaxRequestFaillHtml("", title));
        } else {
            obj.html(GetAjaxRequestFaillHtml("", "暂时没有数据"));
        }
        obj.removeClass("commonShadow");

    } else {
        var noDataMsg = new SinochemPromptMsg("", 2000);
        if ($(".Nodata").length <= 0) {
            noDataMsg.ShowPromptMsg("没有更多数据了");
            //showToast("没有更多数据了", 3000);
            //[由于最后一页提示方式的改变，所以注释]
            //obj.after(noData_html);
        }
    }
}

function GetUserInfo() {
    var UserInfo = getLocVal("UserInfo");
    if (UserInfo == "") {
        showToast("获取用户信息失败");
    } else {
        return strToJson(UserInfo);
    }
}

function propmt(title, cb, cancelCb) {
    appcan.window.confirm({
        title : '提示',
        content : title,
        buttons : ['确定', '取消'],
        callback : function(err, data, dataType, optId) {
            if (err) {
                //如果出错了
                showToast(err);
                return;
            }
            switch (data.toString()) {
            case "0":
                if (cb) {
                    cb();
                }
                break;
            case "1":
                if (cancelCb) {
                    cancelCb();
                }
                break;
            }

        }
    });
}

function commafy(num) {
    num = num + "";
    var decimal = "";
    if (num.split('.').length > 1) {
        decimal = num.split('.')[1];
        num = num.split('.')[0];
    }
    var re = /(-?\d+)(\d{3})/
    while (re.test(num)) {
        num = num.replace(re, "$1,$2")
    }
    return decimal != "" ? num + "." + decimal : num;
}

function guid() {
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }

    return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

function GetUserInfoByUserCode(UserCode, isLogin) {
    var CallData = {
        UserCode : UserCode,
        StrOptions : {}
    };
    console.log('开始');
    callAjaxService("POST", "GetUserInfo", CallData, true, function(result) {
        console.log(result);
        if (result.ResultCode == "0") {
            var data = result.Data;
            setLocVal("UserCode", UserCode);
            setLocVal("UserInfo", data);
            if (isLogin) {
                logs("登录成功" + UserCode);
                var UserInfo = GetUserInfo();
                if (UserInfo.UserStatus == "L") {
                    //若是锁定状态，强制修改密码
                    loadingMsg.HideMsg();
                    new SinochemConfirmationMsg("", function() {
                        openWin('PasswordUpdate', 'PasswordUpdate.html');
                    }).ShowConfirmationMsg("", "您是初次登录，请先修改密码！");
                } else {
                    if(isUpdateAPP){
                        setLocVal("checkUpdate","LoginAfter");
                        var checkUserUpdate=getLocVal("checkUserUpdate");
                        if(checkUserUpdate==""||checkUserUpdate!=getLocVal("UserCode")){
                            getMainWidgetVersion(function() {
                                getWidgetVersion(function() {
                                     CheckBusinessmen();
                                });
                            });
                        }
                        else{
                             CheckBusinessmen();
                        }
                    }
                    else{
                        CheckBusinessmen();
                    }
                }
            }
        } else {
            new SinochemConfirmationMsg("", null).ShowConfirmationMsg("", result.ResultMsg);
        }
    }, function(result) {
        console.log(result);
        noticeMsg.ShowPromptMsg("获取用户失败,请稍后重试！");
    });
}

//判断登录商家的商户情况
function CheckBusinessmen() {
    var TenantID = "";
    var UserInfo = GetUserInfo();
    TenantID = UserInfo.TenantID;
    if(!TenantID || TenantID == null || TenantID == ""){
        GetPartnerReqByUserCode();
    }else{
        setLocVal("CurrentTenantID",UserInfo.TenantID);
        getFXflag(function(FXflag){
            var CallData = {
                LType : "L055",
                StrOptions : {
                    "tenantID" : UserInfo.TenantID
                }
            };
            callAjaxService("POST", "QueryList", CallData, true, function(result) {
                //判断是否有默认商户
                if (result.Data) {
                    var json = [];
                    json[0] = result.Data;
                    setLocVal("MyBusinessmenName", json[0].PartnerName);
                    setLocVal("IsSellerService", json[0].IsSellerService);
                    setLocVal("CurrentTenantID", json[0].TenantID);
                    setLocVal("CurrentPartnerID", json[0].PartnerID);
                    setLocVal("Ref_TenantID", "");
                    if(isUpdateAPP){
                        setLocVal("checkUpdate","LoginAfter");
                        var checkUserUpdate=getLocVal("checkUserUpdate");
                        if(checkUserUpdate==""||checkUserUpdate!=getLocVal("UserCode")){
                            getMainWidgetVersion(function() {
                                getWidgetVersion(function() {
                                    loadingMsg.HideMsg();
                                    if(getLocVal("FirstLogin") == "true" && getLocVal("GestureChengeFlag") != "true"){
                                        setLocVal("FromType","Login");
                                        openWin('GesturePassword', 'OtherOilCompany/GesturePassword.html');
                                    }else{
                                        setLocVal("FirstLogin","false");
                                        if(getLocVal("FXflag") && getLocVal("FXflag") == "FX"){
                                            openWin('HomeNew', 'HomeNew.html');
                                        }else{
                                            openWin('Home', 'Home.html');
                                        }
                                    }
                                });
                            });
                        }
                        else{
                            loadingMsg.HideMsg();
                            if(getLocVal("FirstLogin") == "true" && getLocVal("GestureChengeFlag") != "true"){
                                setLocVal("FromType","Login");
                                openWin('GesturePassword', 'OtherOilCompany/GesturePassword.html');
                            }else{
                                setLocVal("FirstLogin","false");
                                if(getLocVal("FXflag") && getLocVal("FXflag") == "FX"){
                                    openWin('HomeNew', 'HomeNew.html');
                                }else{
                                    openWin('Home', 'Home.html');
                                }
                            }
                        }
                    }
                    else{
                       loadingMsg.HideMsg();
                        if(getLocVal("FirstLogin") == "true" && getLocVal("GestureChengeFlag") != "true"){
                            setLocVal("FromType","Login");
                            openWin('GesturePassword', 'OtherOilCompany/GesturePassword.html');
                        }else{
                            setLocVal("FirstLogin","false");
                            if(getLocVal("FXflag") && getLocVal("FXflag") == "FX"){
                                openWin('HomeNew', 'HomeNew.html');
                            }else{
                                openWin('Home', 'Home.html');
                            }
                        }
                    }
                    
                } else {
                    //无默认商户,去选择商户（只有一个商户也要去选择）
                    //后台逻辑：若有默认商户但不在商户列表中，则认为是无默认商户，返回空
                    var CallData = {
                        RequestPath : "oil/v_1/UserInfo/CheckIsOpenTransaction",
                        StrOptions : {
                            
                        }
                    };
                    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {
                        if (result.Success == true) {
                            if (result && result.Data) {
                                if(result.Data.IsOpen && result.Data.IsOpen == "Y"){
                                    openWin('ChangeBusinessmen', 'ChangeBusinessmen.html');
                                }else{
                                    openWin('Transaction', 'OtherOilCompany/Transaction.html');
                                }
                            }else{
                                warningMsg.ShowPromptMsg(result.Message);
                            }
                        } else {
                            warningMsg.ShowPromptMsg(result.Message);
                        }
                    })
                }
                loadingMsg.HideMsg();
            }, function(result) {
                noticeMsg.ShowPromptMsg("获取商户信息失败,请稍后重试！");
            });
        });
    }
}

function GetPartnerReqByUserCode(){
    var CallData = {
        RequestPath : "oil/v_1/UserInfo/GetPartnerReqByUserCode",
        StrOptions : {
                            
        }
    };
    callAjaxService("GET", "GeneralRequestGET", CallData, true, function(result) {
        loadingMsg.HideMsg();
        if (result && result.Data) {
            var data = result.Data;
            if(data){
                if(data.PRState == "PR10" || data.PRState == "PR11" || data.PRState == "PR20"){
                    openWin('RegistrationModerated', 'OtherOilCompany/RegistrationModerated.html');
                }
                else{
                    openWin('Transaction', 'OtherOilCompany/Transaction.html');
                }
            }
            else{
                openWin('Transaction', 'OtherOilCompany/Transaction.html');
            }
        }
        else{
            loadingMsg.HideMsg();
            warningMsg.ShowPromptMsg(result.Message);
        }
    },function(result){
        loadingMsg.HideMsg();
        warningMsg.ShowPromptMsg("网络不给力，请稍后重试");
    });
}

function getFXflag (cb) {
    var UserInfo = GetUserInfo();
    //获取是否是销售公司的配置
    var CallData = {
        LType:'L150',
        StrOptions:{
            TenantID : UserInfo.TenantID,
            ParmCode: "EBS.FunctionVersion"
        }
    };
    callAjaxService("POST", "QueryList", CallData, true, function(result) {
        console.log(result);
        if(result && result.Data){
            setLocVal("FXflag",result.Data);
            if(cb){
                cb(result.Data);
            }
        }else{
            if(cb){
                cb();
            }
        }
    },function(){
        if(cb){
            cb();
        }
    });
}

//设置下载widget次数
var downCount = 0;
function setOpenWidgetOrHtml(targetType, appid, htmlurl, pageCode, loadEle, cb) {
    switch(targetType) {
    case "TT03":
        openWin(pageCode, htmlurl);
        if (cb) {
            cb();
        }
        setLocVal("OpeningWidget", "N");
        break;
    case "TT02":
        checkWidgetVersion(appid, loadEle, function() {
            if (cb) {
                cb();
            }
            downCount = 1;
            openWidget(appid, htmlurl, pageCode, loadEle);
        });
        setTimeout(function() {
            setLocVal("OpeningWidget", "N");
        }, 1000);
        break;
    case "TT01":
        ueScript("", 'zy_con("page_0", "' + htmlurl + '", 0, 0);');
        if (cb) {
            cb();
        }
        setLocVal("OpeningWidget", "N");
        break;
    case "TT04":
        setLocVal("OutSideUrl", htmlurl);
        setLocVal("fmHeaderTitle", '');
        if (cb) {
            cb();
        }
        openWin("OutSideDetail", "../createmoudel/formModeling.html");
        setLocVal("OpeningWidget", "N");
        break;
    }
}

//打开widget
function openWidget(appID, pageName, pageCode, loadEle) {
    var data = {
        appId : appID,
        animId : '0',
        funcName : "",
        info : 'index.html',
        animDuration : 300
    }
    var warMsg = new SinochemPromptMsg("W", 3000);
    try {
        setLocVal("FirstPage", pageName);
        setLocVal("PageCode", pageCode);
        uexWidget.startWidget(data, function(error) {
            if (error) {
                openWidgetFailCallBack(appID, pageName, pageCode, loadEle);
            }
        });
    } catch(ex) {
        openWidgetFailCallBack(appID, pageName, pageCode, loadEle);
    }
}

function openWidgetFailCallBack(appID, pageName, pageCode, loadEle) {
    if (downCount >= 3) {
        warMsg.ShowPromptMsg("很抱歉功能暂时无法打开，请前往设置页面清空缓存重试！");
        setLocVal("OpeningWidget", "N");
        return;
    }
    var versionInfo = getLocVal("VersionInfo") || "[]";
    versionInfo = JSON.parse(versionInfo);
    for (var i in versionInfo) {
        if (versionInfo[i].AppID == appID) {
            versionInfo[i].Version == "";
            setLocVal("VersionInfo", JSON.stringify(versionInfo));
            downCount++;
            checkWidgetVersion(appID, loadEle, function() {
                openWidget(appID, pageName, pageCode);
            });
            break;
        }
    }
}

function NewGUID() {
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }

    return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}


checkMarket();
//判断市场类型为油销还是湖南版本
function checkMarket (argument) {
    var MarketSort = getLocVal("MarketSort");
    if(MarketSort == "YX"){
        $(".bc-head").addClass("bc-head-YX");
    }
}
//获取手机厂商
function getSysVer (argument) {
    var systemVersion = uexDevice.getInfo('2');
    systemVersion = systemVersion.toLowerCase();
    return systemVersion;
}


//2018年7月15日升级暂不考虑
if(isIOS){
    navigation();
}

//解决IOS沉浸式当行问题
function navigation (argument) {
    if((window.screen.height == 812 && window.screen.width == 375) || (window.screen.height == 896 && window.screen.width == 414) || (window.screen.height == 896 && window.screen.width == 276)){
        $("#header").css("padding-top",".5rem");
    }else{
        $("#header").css("padding-top",".32rem");
    }
}

function ConversionNum (num) {
    if(!num){
        return '0';
    }
    if(isNaN(num)){
        num = num.replace(/,/g,"");
    }
    var thousand = num/10000;
    thousand = thousand.toFixed(2);
    thousand = Number(thousand);
    return thousand;
}
/*格式化为整数*/
function GetNumberByInt(num){
    if(!num){
        return '0';
    }
    if(isNaN(num)){
        num = num.replace(/,/g,"");
    }
    num = Math.abs(Number(num));
    return Math.round(Number(num))
}

function GetYAxisMax(max,min)
{
    var result = (max-min);
    if(result<=0){
       return 1;
    }
   return  Math.ceil(result/5.0);
}
