(function(window) {
    window.TradingBusinessmen = function(params) {
        this.StrOptions = null;
        this.CallBack = function() {
        };
        this.ErrorBack = function() {
        };
        for (var key in params) {
            this[key] = params[key];
        }
    }
    $.extend(TradingBusinessmen.prototype, {
        TradingCall : function(CallData, functionName, extraFun) {
            var thisObj = this;
            callAjaxService("POST", functionName, CallData, true, function(result) {
                if (result.ResultCode == "0") {
                    if (result.Data && result.Data.Items && result.Data.Items == null) {
                        result.Data.Items = [];
                    }
                    if (extraFun) {
                        extraFun(result);
                    }
                    if ( typeof (result.Data) == "string") {
                        result.Data = JSON.parse(result.Data);
                    }
                    thisObj.CallBack(result);
                } else {
					noticeMsg = new SinochemPromptMsg("N", 3000);
                    noticeMsg.ShowPromptMsg(result.ResultMsg);
                }
            }, function(result) {
                loadingMsg.HideMsg();
                thisObj.ErrorBack();
            });
        }
    });

    window.TradingBusinessmenList = function(params) {
        TradingBusinessmen.call(this, {});
        this.LType = "L030";
        this.CurrentPageIndex = 1;
        this.PageSize = 15;
        for (var key in params) {
            this[key] = params[key];
        }
    }
    TradingBusinessmenList.prototype = new TradingBusinessmen();
    $.extend(TradingBusinessmenList.prototype, {
        GetTradingBusinessmenList : function(_pageIndex, _pageSize) {
            if (this.StrOptions == null) {
				noticeMsg = new SinochemPromptMsg("N", 3000);
                noticeMsg.ShowPromptMsg("参数StrOptions必传");
                return;
            }

            this.StrOptions["PageSize"] = this.PageSize;
            this.StrOptions["PageIndex"] = this.CurrentPageIndex;
            if (_pageIndex) {
                this.StrOptions.PageIndex = _pageIndex;
            }
            if (_pageSize) {
                this.StrOptions.PageSize = _pageSize;
            }
            var CallData = {
                LType : this.LType,
                StrOptions : this.StrOptions
            };

            var thisObj = this;
            loadingMsg.ShowLoadingMsg("数据加载中...");
            this.TradingCall(CallData, "QueryList", function(result) {
                result.PageIndex = thisObj.StrOptions.PageIndex;
            });
        },
        ReLoadData : function() {
            this.CurrentPageIndex = 1;
            this.GetTradingBusinessmenList(tradingObj.CurrentPageIndex);
        },
        LoadNextData : function() {
            this.GetTradingBusinessmenList(++tradingObj.CurrentPageIndex);
        }
    });
})(window)
